window.search = {"doc_urls":["index.html#chainerror","index.html#example","index.html#features","tutorial1.html#simple-string-errors","tutorial2.html#simple-chained-string-errors","tutorial2.html#what-did-we-do-here","tutorial3.html#mapping-errors","tutorial4.html#saving-coding-chars","tutorial5.html#the-source-of-errors","tutorial6.html#downcast-the-errors","tutorial7.html#the-root-cause-of-all-errors","tutorial8.html#finding-an-error-cause","tutorial9.html#selective-error-handling","tutorial10.html#errorkind-to-the-rescue","tutorial11.html#debug-for-the-errorkind","end.html#the-end"],"index":{"documentStore":{"docInfo":{"0":{"body":55,"breadcrumbs":1,"title":1},"1":{"body":170,"breadcrumbs":1,"title":1},"10":{"body":1382,"breadcrumbs":3,"title":3},"11":{"body":1349,"breadcrumbs":3,"title":3},"12":{"body":1363,"breadcrumbs":3,"title":3},"13":{"body":1417,"breadcrumbs":2,"title":2},"14":{"body":1406,"breadcrumbs":2,"title":2},"15":{"body":18,"breadcrumbs":1,"title":1},"2":{"body":20,"breadcrumbs":1,"title":1},"3":{"body":94,"breadcrumbs":3,"title":3},"4":{"body":1320,"breadcrumbs":4,"title":4},"5":{"body":44,"breadcrumbs":1,"title":1},"6":{"body":1338,"breadcrumbs":2,"title":2},"7":{"body":1324,"breadcrumbs":3,"title":3},"8":{"body":1337,"breadcrumbs":2,"title":2},"9":{"body":1347,"breadcrumbs":2,"title":2}},"docs":{"0":{"body":"chainerror provides an error backtrace like failure without doing a real backtrace, so even after you strip your binaries, you still have the error backtrace. chainerror has no dependencies! chainerror uses .source() of std::error::Error along with line()! and file()! to provide a nice debug error backtrace. It encapsulates all types, which have Display + Debug and can store the error cause internally. Along with the ChainError<T> struct, chainerror comes with some useful helper macros to save a lot of typing. Debug information is worth it! Now continue reading the Tutorial","breadcrumbs":"chainerror","id":"0","title":"chainerror"},"1":{"body":"Output: $ cargo run -q --example example\nMain Error Report: func1 error calling func2 Error reported by Func2Error: func2 error: calling func3 The root cause was: std::io::Error: Kind( NotFound\n) Debug Error:\nexamples/example.rs:45: func1 error calling func2\nCaused by:\nexamples/example.rs:20: Func2Error(func2 error: calling func3)\nCaused by:\nexamples/example.rs:13: Error reading 'foo.txt'\nCaused by:\nKind(NotFound) use chainerror::*;\nuse std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} fn func3() -> Result<(), Box<Error>> { let filename = \"foo.txt\"; do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?; Ok(())\n} derive_str_cherr!(Func2Error); fn func2() -> ChainResult<(), Func2Error> { func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?; Ok(())\n} enum Func1Error { Func2, IO(String),\n} impl ::std::fmt::Display for Func1Error { fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result { match self { Func1Error::Func2 => write!(f, \"func1 error calling func2\"), Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename), } }\n} impl ::std::fmt::Debug for Func1Error { fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result { write!(f, \"{}\", self) }\n} fn func1() -> ChainResult<(), Func1Error> { func2().map_err(|e| cherr!(e, Func1Error::Func2))?; let filename = String::from(\"bar.txt\"); do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?; Ok(())\n} fn main() { if let Err(e) = func1() { match e.kind() { Func1Error::Func2 => eprintln!(\"Main Error Report: func1 error calling func2\"), Func1Error::IO(filename) => { eprintln!(\"Main Error Report: func1 error reading '{}'\", filename) } } if let Some(e) = e.find_chain_cause::<Func2Error>() { eprintln!(\"\\nError reported by Func2Error: {}\", e) } if let Some(e) = e.root_cause() { let ioerror = e.downcast_ref::<io::Error>().unwrap(); eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror); } eprintln!(\"\\nDebug Error:\\n{:?}\", e); }\n}","breadcrumbs":"Example:","id":"1","title":"Example:"},"10":{"body":"chainerror also has some helper methods: fn is_chain<T: 'static + Display + Debug>(&self) -> bool\nfn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>\nfn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>\nfn root_cause(&self) -> Option<&(dyn Error + 'static)>\nfn find_cause<U: Error + 'static>(&self) -> Option<&U>\nfn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>>\nfn kind<'a>(&'a self) -> &'a T Using downcast_chain_ref::<String>() gives a ChainError<String> , which can be used to call .find_cause::<io::Error>() . if let Some(s) = e.downcast_chain_ref::<String>() { if let Some(ioerror) = s.find_cause::<io::Error>() { or to use .root_cause() , which of course can be of any type implementing std::error::Error . if let Some(e) = s.root_cause() { use crate::chainerror::*;\nuse std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} fn func2() -> Result<(), Box<Error>> { let filename = \"foo.txt\"; do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?; Ok(())\n} fn func1() -> Result<(), Box<Error>> { func2().map_err(mstrerr!(\"func1 error\"))?; Ok(())\n} fn main() -> Result<(), Box<Error>> { if let Err(e) = func1() { eprintln!(\"Error: {}\", e); if let Some(s) = e.downcast_chain_ref::<String>() { if let Some(ioerror) = s.find_cause::<io::Error>() { eprintln!(\"caused by: std::io::Error: {}\", ioerror); match ioerror.kind() { io::ErrorKind::NotFound => eprintln!(\"of kind: std::io::ErrorKind::NotFound\"), _ => {} } } if let Some(e) = s.root_cause() { let ioerror = e.downcast_ref::<io::Error>().unwrap(); eprintln!(\"The root cause was: std::io::Error: {:#?}\", ioerror); } } } Ok(())\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# }","breadcrumbs":"The root cause of all Errors","id":"10","title":"The root cause of all Errors"},"11":{"body":"To distinguish the errors occuring in various places, we can define named string errors with the \"new type\" pattern. derive_str_cherr!(Func2Error);\nderive_str_cherr!(Func1Error); Instead of ChainError<String> we now have struct Func1Error(String) and ChainError<Func1Error> . In the main function you can see, how we can match the different errors. Also see: if let Some(f2err) = f1err.find_chain_cause::<Func2Error>() { as a shortcut to if let Some(f2err) = f1err.find_cause::<ChainError<Func2Error>>() { hiding the ChainError<T> implementation detail. use crate::chainerror::*;\nuse std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} derive_str_cherr!(Func2Error); fn func2() -> Result<(), Box<Error>> { let filename = \"foo.txt\"; do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?; Ok(())\n} derive_str_cherr!(Func1Error); fn func1() -> Result<(), Box<Error>> { func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?; Ok(())\n} fn main() -> Result<(), Box<Error>> { if let Err(e) = func1() { if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() { eprintln!(\"Func1Error: {}\", f1err); if let Some(f2err) = f1err.find_cause::<ChainError<Func2Error>>() { eprintln!(\"Func2Error: {}\", f2err); } if let Some(f2err) = f1err.find_chain_cause::<Func2Error>() { eprintln!(\"Debug Func2Error:\\n{:?}\", f2err); } } } Ok(())\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# }","breadcrumbs":"Finding an Error cause","id":"11","title":"Finding an Error cause"},"12":{"body":"What about functions returning different Error types? In this example func1() can return either Func1ErrorFunc2 or Func1ErrorIO . We might want to match on func1() with something like: fn main() -> Result<(), Box<Error>> { match func1() { Err(e) if let Some(s) = e.downcast_chain_ref::<Func1ErrorIO>() => eprintln!(\"Func1ErrorIO:\\n{:?}\", s), Err(e) if let Some(s) = e.downcast_chain_ref::<Func1ErrorFunc2>() => eprintln!(\"Func1ErrorFunc2:\\n{:?}\", s), Ok(_) => {}, } Ok(())\n} but this is not valid rust code, so we end up doing it the hard way. In the next chapter, we will see, how to solve this more elegantly. use crate::chainerror::*;\nuse std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} derive_str_cherr!(Func2Error); fn func2() -> Result<(), Box<Error>> { let filename = \"foo.txt\"; do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?; Ok(())\n} derive_str_cherr!(Func1ErrorFunc2);\nderive_str_cherr!(Func1ErrorIO); fn func1() -> Result<(), Box<Error>> { func2().map_err(mstrerr!(Func1ErrorFunc2, \"func1 error calling func2\"))?; let filename = \"bar.txt\"; do_some_io().map_err(mstrerr!(Func1ErrorIO, \"Error reading '{}'\", filename))?; Ok(())\n} fn main() -> Result<(), Box<Error>> { if let Err(e) = func1() { if let Some(s) = e.downcast_ref::<ChainError<Func1ErrorIO>>() { eprintln!(\"Func1ErrorIO:\\n{:?}\", s); } if let Some(s) = e.downcast_chain_ref::<Func1ErrorFunc2>() { eprintln!(\"Func1ErrorFunc2:\\n{:?}\", s); } } Ok(())\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# }","breadcrumbs":"Selective Error Handling","id":"12","title":"Selective Error Handling"},"13":{"body":"To cope with different kind of errors, we introduce the kind of an error Func1ErrorKind with an enum. Because we derive Debug and implement Display our Func1ErrorKind enum, this enum can be used as a std::error::Error . Not using String errors anymore, the cherr!() macro seen in the beginning of the tutorial has to be used again. Only returning Func1ErrorKind in func1() now let us get rid of Result<(), Box<Error>> and we can use ChainResult<(), Func1ErrorKind> . In main we can now directly use the methods of ChainError<T> without downcasting the error first. Also a nice match on ChainError<T>.kind() is now possible, which returns &T , meaning &Func1ErrorKind here. use crate::chainerror::*;\nuse std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} derive_str_cherr!(Func2Error); fn func2() -> Result<(), Box<Error>> { let filename = \"foo.txt\"; do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?; Ok(())\n} #[derive(Debug)]\nenum Func1ErrorKind { Func2, IO(String),\n} impl ::std::fmt::Display for Func1ErrorKind { fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result { match self { Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"), Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename), } }\n} fn func1() -> ChainResult<(), Func1ErrorKind> { func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?; let filename = String::from(\"bar.txt\"); do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(filename)))?; Ok(())\n} fn main() -> Result<(), Box<Error>> { if let Err(e) = func1() { match e.kind() { Func1ErrorKind::Func2 => eprintln!(\"Main Error Report: func1 error calling func2\"), Func1ErrorKind::IO(filename) => { eprintln!(\"Main Error Report: func1 error reading '{}'\", filename) } } if let Some(e) = e.find_chain_cause::<Func2Error>() { eprintln!(\"\\nError reported by Func2Error: {}\", e) } eprintln!(\"\\nDebug Error:\\n{:?}\", e); } Ok(())\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# }","breadcrumbs":"ErrorKind to the rescue","id":"13","title":"ErrorKind to the rescue"},"14":{"body":"One small improvement at the end of the tutorial is to fix the debug output of Func1ErrorKind . As you probably noticed, the output doesn't say much of the enum. Debug Error:\nsrc/main.rs:35: Func2\n[…] As a lazy shortcut, we implement Debug by calling Display and end up with Debug Error:\nsrc/main.rs:40: func1 error calling func2\n[…} which gives us a lot more detail. use crate::chainerror::*;\nuse std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} derive_str_cherr!(Func2Error); fn func2() -> Result<(), Box<Error>> { let filename = \"foo.txt\"; do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?; Ok(())\n} enum Func1ErrorKind { Func2, IO(String),\n} impl ::std::fmt::Display for Func1ErrorKind { fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result { match self { Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"), Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename), } }\n} impl ::std::fmt::Debug for Func1ErrorKind { fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result { write!(f, \"{}\", self) }\n} fn func1() -> ChainResult<(), Func1ErrorKind> { func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?; let filename = String::from(\"bar.txt\"); do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(filename)))?; Ok(())\n} fn main() -> Result<(), Box<Error>> { if let Err(e) = func1() { match e.kind() { Func1ErrorKind::Func2 => eprintln!(\"Main Error Report: func1 error calling func2\"), Func1ErrorKind::IO(filename) => { eprintln!(\"Main Error Report: func1 error reading '{}'\", filename) } } if let Some(e) = e.find_chain_cause::<Func2Error>() { eprintln!(\"\\nError reported by Func2Error: {}\", e) } eprintln!(\"\\nDebug Error:\\n{:?}\", e); } Ok(())\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# }","breadcrumbs":"Debug for the ErrorKind","id":"14","title":"Debug for the ErrorKind"},"15":{"body":"That's it for now… Happy error handling! To report issues, submit pull request or for the source code, examples and the book source, visit the Git Repo .","breadcrumbs":"The End","id":"15","title":"The End"},"2":{"body":"no-fileline : completely turn off storing filename and line display-cause : turn on printing a backtrace of the errors in Display no-debug-cause : turn off printing a backtrace of the errors in Debug","breadcrumbs":"Features","id":"2","title":"Features"},"3":{"body":"An easy way of doing error handling in rust is by returning String as a Box<std::error::Error> . If the rust main function returns an Err() , this Err() will be displayed with std::fmt::Debug . As you can see by running the example (by pressing the \"Play\" button in upper right of the code block), this only prints out the last Error . Error: StringError(\"func1 error\") The next chapters of this tutorial show how chainerror adds more information and improves inspecting the sources of an error. You can also run the tutorial examples in the checked out chainerror git repo . $ cargo run -q --example tutorial1 use std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} fn func2() -> Result<(), Box<Error>> { if let Err(_) = do_some_io() { Err(\"func2 error\")?; } Ok(())\n} fn func1() -> Result<(), Box<Error>> { if let Err(_) = func2() { Err(\"func1 error\")?; } Ok(())\n} fn main() -> Result<(), Box<Error>> { func1()\n}","breadcrumbs":"Simple String Errors","id":"3","title":"Simple String Errors"},"4":{"body":"With relatively small changes and the help of the cherr! macro of the chainerror crate the String errors are now chained together. Press the play button in the upper right corner and see the nice debug output. use crate::chainerror::*; use std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} fn func2() -> Result<(), Box<Error>> { if let Err(e) = do_some_io() { Err(cherr!(e, \"func2 error\"))?; } Ok(())\n} fn func1() -> Result<(), Box<Error>> { if let Err(e) = func2() { Err(cherr!(e, \"func1 error\"))?; } Ok(())\n} fn main() -> Result<(), Box<Error>> { func1()\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# }","breadcrumbs":"Simple Chained String Errors","id":"4","title":"Simple Chained String Errors"},"5":{"body":"if let Err(e) = do_some_io() { Err(cherr!(e, \"func2 error\"))?; } The macro cherr!(olderror, newerror) stores olderror as the source/cause of newerror along with the filename ( file!() ) and line number ( line!() ) and returns newerror . Err()? then returns the inner error applying .into() , so that we again have a Err(Box<Error>) as a result. The Debug implementation of ChainError<T> (which is returned by cherr!() ) prints the Debug of T prefixed with the stored filename and line number. ChainError<T> in our case is ChainError<String> .","breadcrumbs":"What did we do here?","id":"5","title":"What did we do here?"},"6":{"body":"Now let's get more rust idiomatic by using .map_err() . use crate::chainerror::*; use std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} fn func2() -> Result<(), Box<Error>> { do_some_io().map_err(|e| cherr!(e, \"func2 error\"))?; Ok(())\n} fn func1() -> Result<(), Box<Error>> { func2().map_err(|e| cherr!(e, \"func1 error\"))?; Ok(())\n} fn main() -> Result<(), Box<Error>> { if let Err(e) = func1() { eprintln!(\"{:?}\", e); } Ok(())\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# } If you compare the output to the previous example, you will see, that: Error: src/main.rs:19: \"func1 error\" changed to just: src/main.rs:16: \"func1 error\" This is, because we caught the error of func1() in main() and print it out ourselves. We can now control, whether to output in Debug or Display mode. Maybe depending on --debug as a CLI argument.","breadcrumbs":"Mapping Errors","id":"6","title":"Mapping Errors"},"7":{"body":"Because decorating an error with more information should not let you jump through hoops, chainerror has a quick macro for that. mstrerror!() fits right into .map_err() letting you quickly add more debug strings. mstrerror!() even understands format!() syntax like println!() . use crate::chainerror::*;\nuse std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} fn func2() -> Result<(), Box<Error>> { let filename = \"foo.txt\"; do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?; Ok(())\n} fn func1() -> Result<(), Box<Error>> { func2().map_err(mstrerr!(\"func1 error\"))?; Ok(())\n} fn main() -> Result<(), Box<Error>> { if let Err(e) = func1() { eprintln!(\"{:?}\", e); } Ok(())\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# }","breadcrumbs":"Saving coding chars","id":"7","title":"Saving coding chars"},"8":{"body":"Sometimes you want to inspect the source() of an Error . chainerror implements std::error::Error::source() , so you can get the cause of an error. use crate::chainerror::*;\nuse std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} fn func2() -> Result<(), Box<Error>> { let filename = \"foo.txt\"; do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?; Ok(())\n} fn func1() -> Result<(), Box<Error>> { if let Err(e) = func2() { if let Some(s) = e.source() { eprintln!(\"func2 failed because of '{}'\", s); Err(e).map_err(mstrerr!(\"func1 error\"))?; } } Ok(())\n} fn main() -> Result<(), Box<Error>> { if let Err(e) = func1() { eprintln!(\"{}\", e); } Ok(())\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# } Note, that because we changed the output of the error in main() from Debug to Display , we don't see the error backtrace with filename and line number. To enable the Display backtrace, you have to enable the feature display-cause for chainerror .","breadcrumbs":"The source() of Errors","id":"8","title":"The source() of Errors"},"9":{"body":"std::error::Error comes with some helper methods to get to the original object of the &(dyn Error + 'static) returned by .source() . pub fn downcast_ref<T: Error + 'static>(&self) -> Option<&T>\npub fn downcast_mut<T: Error + 'static>(&mut self) -> Option<&mut T> This is how it looks like, when using those: use crate::chainerror::*;\nuse std::error::Error;\nuse std::io;\nuse std::result::Result; fn do_some_io() -> Result<(), Box<Error>> { Err(io::Error::from(io::ErrorKind::NotFound))?; Ok(())\n} fn func2() -> Result<(), Box<Error>> { let filename = \"foo.txt\"; do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?; Ok(())\n} fn func1() -> Result<(), Box<Error>> { func2().map_err(mstrerr!(\"func1 error\"))?; Ok(())\n} fn main() -> Result<(), Box<Error>> { if let Err(e) = func1() { eprintln!(\"Error: {}\", e); let mut s = e.as_ref(); while let Some(c) = s.source() { if let Some(ioerror) = c.downcast_ref::<io::Error>() { eprintln!(\"caused by: std::io::Error: {}\", ioerror); match ioerror.kind() { io::ErrorKind::NotFound => eprintln!(\"of kind: std::io::ErrorKind::NotFound\"), _ => {} } } else { eprintln!(\"caused by: {}\", c); } s = c; } } Ok(())\n}\n# #[allow(dead_code)]\n# mod chainerror {\n# /*!\n# # `chainerror` provides an error backtrace without doing a real backtrace, so even after you `strip` your\n# binaries, you still have the error backtrace.\n# # `chainerror` has no dependencies!\n# # `chainerror` uses `.source()` of `std::error::Error` along with `line()!` and `file()!` to provide a nice debug error backtrace.\n# It encapsulates all types, which have `Display + Debug` and can store the error cause internally.\n# # Along with the `ChainError<T>` struct, `chainerror` comes with some useful helper macros to save a lot of typing.\n# # ## Features\n# # `no-fileline`\n# : completely turn off storing filename and line\n# # `display-cause`\n# : turn on printing a backtrace of the errors in `Display`\n# # `no-debug-cause`\n# : turn off printing a backtrace of the errors in `Debug`\n# # # # Tutorial\n# # Read the [Tutorial](https://haraldh.github.io/chainerror/tutorial1.html)\n# # # Examples\n# # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:20: func1 error\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # # ~~~rust\n# use chainerror::*;\n# use std::error::Error;\n# use std::io;\n# use std::result::Result;\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func3() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# func3().map_err(mstrerr!(Func2Error, \"func2 error: calling func3\"))?;\n# Ok(())\n# }\n# # enum Func1Error {\n# Func2,\n# IO(String),\n# }\n# # impl ::std::fmt::Display for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# match self {\n# Func1Error::Func2 => write!(f, \"func1 error calling func2\"),\n# Func1Error::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# }\n# }\n# }\n# # impl ::std::fmt::Debug for Func1Error {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self)\n# }\n# }\n# # fn func1() -> ChainResult<(), Func1Error> {\n# func2().map_err(|e| cherr!(e, Func1Error::Func2))?;\n# let filename = String::from(\"bar.txt\");\n# do_some_io().map_err(|e| cherr!(e, Func1Error::IO(filename)))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# assert!(\n# match e.kind() {\n# Func1Error::Func2 => {\n# eprintln!(\"Main Error Report: func1 error calling func2\");\n# true\n# }\n# Func1Error::IO(filename) => {\n# eprintln!(\"Main Error Report: func1 error reading '{}'\", filename);\n# false\n# }\n# }\n# );\n# # assert!(e.find_chain_cause::<Func2Error>().is_some());\n# # if let Some(e) = e.find_chain_cause::<Func2Error>() {\n# eprintln!(\"\\nError reported by Func2Error: {}\", e)\n# }\n# # # assert!(e.root_cause().is_some());\n# # if let Some(e) = e.root_cause() {\n# let ioerror = e.downcast_ref::<io::Error>().unwrap();\n# eprintln!(\"\\nThe root cause was: std::io::Error: {:#?}\", ioerror);\n# }\n# # assert_eq!(\n# format!(\"\\n{:?}\\n\", e), r#\"\n# src/lib.rs:47: func1 error calling func2\n# Caused by:\n# src/lib.rs:22: Func2Error(func2 error: calling func3)\n# Caused by:\n# src/lib.rs:15: Error reading 'foo.txt'\n# Caused by:\n# Kind(NotFound)\n# \"#\n# );\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # !*/\n# # use std::any::TypeId;\n# use std::error::Error;\n# use std::fmt::{Debug, Display, Formatter, Result};\n# # /** chains an inner error kind `T` with a causing error\n# **/\n# pub struct ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# occurrence: Option<(u32, &'static str)>,\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# }\n# # /// convenience type alias\n# pub type ChainResult<O, E> = std::result::Result<O, ChainError<E>>;\n# # impl<T: 'static + Display + Debug> ChainError<T> {\n# #[cfg(not(feature = \"no-fileline\"))]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self {\n# occurrence,\n# kind,\n# error_cause,\n# }\n# }\n# # #[cfg(feature = \"no-fileline\")]\n# /// Use the `cherr!()` or `mstrerr!()` macro instead of calling this directly\n# pub fn new(\n# kind: T,\n# error_cause: Option<Box<dyn Error + 'static>>,\n# _occurrence: Option<(u32, &'static str)>,\n# ) -> Self {\n# Self { kind, error_cause }\n# }\n# # /// return the root cause of the error chain, if any exists\n# pub fn root_cause(&self) -> Option<&(dyn Error + 'static)> {\n# let mut cause = self as &(dyn Error + 'static);\n# while let Some(c) = cause.source() {\n# cause = c;\n# }\n# Some(cause)\n# }\n# # /** find the first error cause of type U, if any exists\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<io::Error>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# }\n# # else {\n# # panic!();\n# # }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# **/\n# pub fn find_cause<U: Error + 'static>(&self) -> Option<&U> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<U>() {\n# return cause.downcast_ref::<U>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** find the first error cause of type ChainError<U>, if any exists\n# # Same as `find_cause`, but hides the `ChainError<U>` implementation internals\n# # # Examples\n# # ~~~rust,ignore\n# /// Instead of writing\n# err.find_cause::<ChainError<FooError>>();\n# # /// leave out the ChainError<T> implementation detail\n# err.find_chain_cause::<FooError>();\n# ~~~\n# # **/\n# pub fn find_chain_cause<U: Error + 'static>(&self) -> Option<&ChainError<U>> {\n# let mut cause = self as &(dyn Error + 'static);\n# loop {\n# if cause.is::<ChainError<U>>() {\n# return cause.downcast_ref::<ChainError<U>>();\n# }\n# # match cause.source() {\n# Some(c) => cause = c,\n# None => return None,\n# }\n# }\n# }\n# # /** return a reference to T of `ChainError<T>`\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# fn do_some_io() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # #[derive(Debug)]\n# enum Func1ErrorKind {\n# Func2,\n# IO(String),\n# }\n# # // impl ::std::fmt::Display for Func1ErrorKind {…}\n# # impl ::std::fmt::Display for Func1ErrorKind {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # Func1ErrorKind::Func2 => write!(f, \"func1 error calling func2\"),\n# # Func1ErrorKind::IO(filename) => write!(f, \"Error reading '{}'\", filename),\n# # }\n# # }\n# # }\n# # fn func1() -> ChainResult<(), Func1ErrorKind> {\n# func2().map_err(|e| cherr!(e, Func1ErrorKind::Func2))?;\n# do_some_io().map_err(|e| cherr!(e, Func1ErrorKind::IO(\"bar.txt\".into())))?;\n# Ok(())\n# }\n# # fn main() {\n# if let Err(e) = func1() {\n# match e.kind() {\n# Func1ErrorKind::Func2 => {},\n# Func1ErrorKind::IO(filename) => panic!(),\n# }\n# }\n# # else {\n# # unreachable!();\n# # }\n# }\n# ~~~\n# # **/\n# pub fn kind<'a>(&'a self) -> &'a T {\n# &self.kind\n# }\n# }\n# # /** convenience trait to hide the `ChainError<T>` implementation internals\n# **/\n# pub trait ChainErrorDown {\n# /** test if of type `ChainError<T>`\n# **/\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool;\n# /** downcast to a reference of `ChainError<T>`\n# **/\n# fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>>;\n# /** downcast to a mutable reference of `ChainError<T>`\n# **/\n# fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>>;\n# }\n# # impl<U: 'static + Display + Debug> ChainErrorDown for ChainError<U> {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# TypeId::of::<T>() == TypeId::of::<U>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&*(self as *const dyn Error as *const &ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# if self.is_chain::<T>() {\n# unsafe { Some(&mut *(self as *mut dyn Error as *mut &mut ChainError<T>)) }\n# } else {\n# None\n# }\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl ChainErrorDown for dyn Error + 'static + Send + Sync {\n# fn is_chain<T: 'static + Display + Debug>(&self) -> bool {\n# self.is::<ChainError<T>>()\n# }\n# # fn downcast_chain_ref<T: 'static + Display + Debug>(&self) -> Option<&ChainError<T>> {\n# self.downcast_ref::<ChainError<T>>()\n# }\n# # fn downcast_chain_mut<T: 'static + Display + Debug>(&mut self) -> Option<&mut ChainError<T>> {\n# self.downcast_mut::<ChainError<T>>()\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Error for &mut ChainError<T> {\n# fn source(&self) -> Option<&(dyn Error + 'static)> {\n# if let Some(ref e) = self.error_cause {\n# Some(e.as_ref())\n# } else {\n# None\n# }\n# }\n# }\n# # impl<T: 'static + Display + Debug> Display for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# write!(f, \"{}\", self.kind)?;\n# # #[cfg(feature = \"display-cause\")]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Display::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # impl<T: 'static + Display + Debug> Debug for ChainError<T> {\n# fn fmt(&self, f: &mut Formatter) -> Result {\n# #[cfg(not(feature = \"no-fileline\"))]\n# {\n# if let Some(o) = self.occurrence {\n# write!(f, \"{}:{}: \", o.1, o.0)?;\n# }\n# }\n# # if self.is_chain::<String>() {\n# Display::fmt(&self.kind, f)?;\n# } else {\n# Debug::fmt(&self.kind, f)?;\n# }\n# # #[cfg(not(feature = \"no-debug-cause\"))]\n# {\n# if let Some(e) = self.source() {\n# writeln!(f, \"\\nCaused by:\")?;\n# Debug::fmt(&e, f)?;\n# }\n# }\n# Ok(())\n# }\n# }\n# # /** creates a new `ChainError<T>`\n# # # Examples\n# # Create a new ChainError<FooError>, where `FooError` must implement `Display` and `Debug`.\n# ~~~rust\n# # use chainerror::*;\n# #\n# # #[derive(Debug)]\n# enum FooError {\n# Bar,\n# Baz(&'static str),\n# }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# # // impl ::std::fmt::Display for FooError\n# # fn do_some_stuff() -> bool {\n# false\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# if ! do_some_stuff() {\n# Err(cherr!(FooError::Baz(\"Error\")))?;\n# }\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # Additionally an error cause can be added.\n# # ~~~rust\n# # use chainerror::*;\n# # use std::io;\n# # use std::error::Error;\n# #\n# # #[derive(Debug)]\n# # enum FooError {\n# # Bar,\n# # Baz(&'static str),\n# # }\n# #\n# # impl ::std::fmt::Display for FooError {\n# # fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# # match self {\n# # FooError::Bar => write!(f, \"Bar Error\"),\n# # FooError::Baz(s) => write!(f, \"Baz Error: '{}'\", s),\n# # }\n# # }\n# # }\n# #\n# fn do_some_stuff() -> Result<(), Box<Error>> {\n# Err(io::Error::from(io::ErrorKind::NotFound))?;\n# Ok(())\n# }\n# # fn func() -> ChainResult<(), FooError> {\n# do_some_stuff().map_err(\n# |e| cherr!(e, FooError::Baz(\"Error\"))\n# )?;\n# Ok(())\n# }\n# #\n# # pub fn main() {\n# # match func().unwrap_err().kind() {\n# # FooError::Baz(s) if s == &\"Error\" => {},\n# # _ => panic!(),\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! cherr {\n# ( $k:expr ) => {\n# ChainError::<_>::new($k, None, Some((line!(), file!())))\n# };\n# ( $e:expr, $k:expr ) => {\n# ChainError::<_>::new($k, Some(Box::from($e)), Some((line!(), file!())))\n# };\n# }\n# # /** convenience macro for |e| cherr!(e, format!(…))\n# # # Examples\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(\"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(\"func1 error\"))?;\n# Ok(())\n# }\n# # # fn main() {\n# # if let Err(e) = func1() {\n# # assert_eq!(\n# # format!(\"\\n{:?}\\n\", e), r#\"\n# # src/lib.rs:20: func1 error\n# # Caused by:\n# # src/lib.rs:15: Error reading 'foo.txt'\n# # Caused by:\n# # Kind(NotFound)\n# # \"#\n# # );\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # `mstrerr!()` can also be used to map a new `ChainError<T>`, where T was defined with\n# `derive_str_cherr!(T)`\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> Result<(), Box<Error>> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# **/\n# #[macro_export]\n# macro_rules! mstrerr {\n# ( $t:ident, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $t:path, $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, $t (format!($v, $( $more , )* )))\n# };\n# ( $v:expr $(, $more:expr)* ) => {\n# |e| cherr!(e, format!($v, $( $more , )* ))\n# };\n# }\n# # /** convenience macro to create a \"new type\" T(String) and implement Display + Debug for T\n# # ~~~rust\n# # use crate::chainerror::*;\n# # use std::error::Error;\n# # use std::io;\n# # use std::result::Result;\n# #\n# # fn do_some_io() -> Result<(), Box<Error>> {\n# # Err(io::Error::from(io::ErrorKind::NotFound))?;\n# # Ok(())\n# # }\n# #\n# derive_str_cherr!(Func2Error);\n# # fn func2() -> ChainResult<(), Func2Error> {\n# let filename = \"foo.txt\";\n# do_some_io().map_err(mstrerr!(Func2Error, \"Error reading '{}'\", filename))?;\n# Ok(())\n# }\n# # derive_str_cherr!(Func1Error);\n# # fn func1() -> Result<(), Box<Error>> {\n# func2().map_err(mstrerr!(Func1Error, \"func1 error\"))?;\n# Ok(())\n# }\n# #\n# # fn main() {\n# # if let Err(e) = func1() {\n# # if let Some(f1err) = e.downcast_chain_ref::<Func1Error>() {\n# # assert!(f1err.find_cause::<ChainError<Func2Error>>().is_some());\n# # assert!(f1err.find_chain_cause::<Func2Error>().is_some());\n# # } else {\n# # panic!();\n# # }\n# # } else {\n# # unreachable!();\n# # }\n# # }\n# ~~~\n# # **/\n# #[macro_export]\n# macro_rules! derive_str_cherr {\n# ($e:ident) => {\n# struct $e(String);\n# impl ::std::fmt::Display for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}\", self.0)\n# }\n# }\n# impl ::std::fmt::Debug for $e {\n# fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {\n# write!(f, \"{}({})\", stringify!($e), self.0)\n# }\n# }\n# impl ::std::error::Error for $e {}\n# };\n# }\n# }","breadcrumbs":"Downcast the Errors","id":"9","title":"Downcast the Errors"}},"length":16,"save":true},"fields":["title","body","breadcrumbs"],"index":{"body":{"root":{"_":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}},"o":{"c":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"a":{"d":{"d":{"df":2,"docs":{"3":{"tf":1.0},"7":{"tf":1.0}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{},"g":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":2,"docs":{"13":{"tf":1.0},"5":{"tf":1.0}}}}},"df":0,"docs":{}},"l":{"df":0,"docs":{},"i":{"a":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"(":{"d":{"df":0,"docs":{},"e":{"a":{"d":{"_":{"c":{"df":0,"docs":{},"o":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":12,"docs":{"0":{"tf":1.4142135623730951},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"5":{"tf":1.0},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"n":{"df":0,"docs":{},"y":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"p":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"5":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"6":{"tf":1.0}}}}}}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"!":{"(":{"df":0,"docs":{},"e":{".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"f":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{">":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"q":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"b":{"a":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"a":{"c":{"df":12,"docs":{"0":{"tf":2.0},"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"2":{"tf":1.4142135623730951},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.8284271247461903},"9":{"tf":2.449489742783178}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"df":1,"docs":{"12":{"tf":1.0}}}}}},"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}},"z":{"(":{"&":{"'":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"i":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}}},"l":{"df":0,"docs":{},"o":{"c":{"df":0,"docs":{},"k":{"df":1,"docs":{"3":{"tf":1.0}}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":1,"docs":{"15":{"tf":1.0}}},"l":{"df":10,"docs":{"10":{"tf":2.6457513110645907},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}}},"x":{"<":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":12,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":4.795831523312719},"11":{"tf":4.795831523312719},"12":{"tf":4.898979485566356},"13":{"tf":4.795831523312719},"14":{"tf":4.69041575982343},"3":{"tf":2.0},"4":{"tf":4.795831523312719},"6":{"tf":4.795831523312719},"7":{"tf":4.795831523312719},"8":{"tf":4.795831523312719},"9":{"tf":4.795831523312719}}}}}}},"s":{"df":0,"docs":{},"t":{"d":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"3":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}}}}}},"c":{".":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"9":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":11,"docs":{"1":{"tf":2.6457513110645907},"10":{"tf":3.0},"11":{"tf":2.8284271247461903},"12":{"tf":3.0},"13":{"tf":3.1622776601683795},"14":{"tf":3.4641016151377544},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"o":{"df":2,"docs":{"1":{"tf":1.0},"3":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"e":{"df":1,"docs":{"5":{"tf":1.0}}}},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":1,"docs":{"6":{"tf":1.0}}}}},"s":{"df":13,"docs":{"0":{"tf":1.0},"1":{"tf":2.23606797749979},"10":{"tf":5.0990195135927845},"11":{"tf":5.0},"12":{"tf":4.898979485566356},"13":{"tf":4.898979485566356},"14":{"tf":4.898979485566356},"2":{"tf":1.4142135623730951},"4":{"tf":4.898979485566356},"6":{"tf":4.898979485566356},"7":{"tf":4.898979485566356},"8":{"tf":5.0990195135927845},"9":{"tf":4.898979485566356}},"e":{".":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}},"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":2.23606797749979}},"f":{"df":0,"docs":{},"g":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":2.0},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"<":{"_":{">":{":":{":":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"(":{"$":{"df":0,"docs":{},"k":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"<":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}}},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":3,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"5":{"tf":1.0}}}}},"t":{">":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":4.898979485566356},"11":{"tf":4.898979485566356},"12":{"tf":4.795831523312719},"13":{"tf":4.898979485566356},"14":{"tf":4.795831523312719},"4":{"tf":4.795831523312719},"5":{"tf":1.4142135623730951},"6":{"tf":4.795831523312719},"7":{"tf":4.795831523312719},"8":{"tf":4.795831523312719},"9":{"tf":4.795831523312719}}},"u":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}}},"df":13,"docs":{"0":{"tf":2.23606797749979},"1":{"tf":1.0},"10":{"tf":3.1622776601683795},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.0},"14":{"tf":3.0},"3":{"tf":1.4142135623730951},"4":{"tf":3.1622776601683795},"6":{"tf":3.0},"7":{"tf":3.1622776601683795},"8":{"tf":3.3166247903554},"9":{"tf":3.0}}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"<":{"df":0,"docs":{},"o":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.8284271247461903},"14":{"tf":2.6457513110645907},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}}}}}}}}},"n":{"df":0,"docs":{},"g":{"df":3,"docs":{"4":{"tf":1.0},"6":{"tf":1.0},"8":{"tf":1.0}}}},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"12":{"tf":1.0},"3":{"tf":1.0}}}}}},"r":{"df":1,"docs":{"7":{"tf":1.0}}}},"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"k":{"df":1,"docs":{"3":{"tf":1.0}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.3166247903554},"14":{"tf":3.3166247903554},"4":{"tf":3.0},"6":{"tf":3.3166247903554},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}},"o":{"df":0,"docs":{},"l":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"5":{"tf":1.0}}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":11,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.0},"14":{"tf":1.7320508075688772},"4":{"tf":2.0},"5":{"tf":1.0},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"6":{"tf":1.0}}}},"o":{"d":{"df":0,"docs":{},"e":{"df":4,"docs":{"12":{"tf":1.0},"15":{"tf":1.0},"3":{"tf":1.0},"7":{"tf":1.0}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.4142135623730951}}},"p":{"a":{"df":0,"docs":{},"r":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":11,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"2":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"n":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"u":{"df":1,"docs":{"0":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":1,"docs":{"6":{"tf":1.0}}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}}}},"p":{"df":0,"docs":{},"e":{"df":1,"docs":{"13":{"tf":1.0}}}},"r":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"4":{"tf":1.0}}}}}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":1,"docs":{"10":{"tf":1.0}}}}}},"r":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{":":{":":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"4":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}},"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{"(":{"&":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},">":{"(":{"&":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":3.4641016151377544},"11":{"tf":3.1622776601683795},"12":{"tf":3.1622776601683795},"13":{"tf":3.1622776601683795},"14":{"tf":3.1622776601683795},"4":{"tf":3.1622776601683795},"6":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":3.1622776601683795},"9":{"tf":3.1622776601683795}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":14,"docs":{"0":{"tf":1.7320508075688772},"1":{"tf":1.0},"10":{"tf":3.872983346207417},"11":{"tf":3.872983346207417},"12":{"tf":3.872983346207417},"13":{"tf":4.0},"14":{"tf":4.47213595499958},"2":{"tf":1.4142135623730951},"4":{"tf":4.0},"5":{"tf":1.4142135623730951},"6":{"tf":4.123105625617661},"7":{"tf":4.0},"8":{"tf":4.0},"9":{"tf":3.872983346207417}}}}},"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"7":{"tf":1.0}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.4142135623730951},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":1,"docs":{"13":{"tf":1.0}},"e":{"(":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.0},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"_":{"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.23606797749979},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}}}}}}}},"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.23606797749979},"11":{"tf":2.6457513110645907},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}}},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"y":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{"(":{"&":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":13,"docs":{"0":{"tf":1.0},"10":{"tf":5.744562646538029},"11":{"tf":5.477225575051661},"12":{"tf":5.477225575051661},"13":{"tf":5.5677643628300215},"14":{"tf":5.5677643628300215},"2":{"tf":1.4142135623730951},"3":{"tf":1.0},"4":{"tf":5.477225575051661},"6":{"tf":5.5677643628300215},"7":{"tf":5.477225575051661},"8":{"tf":5.744562646538029},"9":{"tf":5.477225575051661}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"u":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}}}}}},"o":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"_":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"(":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"m":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"\"":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.0},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}}}}}}}},"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"|":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.4142135623730951},"6":{"tf":1.7320508075688772},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":13,"docs":{"1":{"tf":1.0},"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"3":{"tf":1.4142135623730951},"4":{"tf":3.0},"5":{"tf":1.0},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"(":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}}},"df":0,"docs":{}}}}}},"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"13":{"tf":1.0},"14":{"tf":1.0},"3":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"n":{"'":{"df":0,"docs":{},"t":{"df":1,"docs":{"14":{"tf":1.0}}}},"df":0,"docs":{}}}},"n":{"'":{"df":0,"docs":{},"t":{"df":1,"docs":{"8":{"tf":1.0}}}},"df":0,"docs":{}},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":1,"docs":{"10":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"<":{"df":0,"docs":{},"t":{"df":1,"docs":{"9":{"tf":1.0}}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"<":{"df":0,"docs":{},"t":{"df":1,"docs":{"9":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"y":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":3.0}}}}},"df":0,"docs":{},"e":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},".":{"a":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":1,"docs":{"9":{"tf":1.0}}}}}},"df":0,"docs":{}}},"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":1,"docs":{"12":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":1,"docs":{"10":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{"(":{")":{".":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"w":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"p":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":1,"docs":{"8":{"tf":1.0}}},"df":0,"docs":{}}}}}},":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"i":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}},"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":1,"docs":{"3":{"tf":1.0}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":4.123105625617661},"11":{"tf":4.0},"12":{"tf":4.0},"13":{"tf":4.242640687119285},"14":{"tf":4.242640687119285},"4":{"tf":4.0},"6":{"tf":4.123105625617661},"7":{"tf":4.123105625617661},"8":{"tf":4.123105625617661},"9":{"tf":4.123105625617661}},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"12":{"tf":1.0}}}}}}},"df":0,"docs":{}}}},"n":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"8":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"c":{"a":{"df":0,"docs":{},"p":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"d":{"df":3,"docs":{"12":{"tf":1.0},"14":{"tf":1.4142135623730951},"15":{"tf":1.0}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.8284271247461903},"14":{"tf":2.449489742783178},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"n":{"!":{"(":{"\"":{"\\":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"t":{"df":0,"docs":{},"h":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":1,"docs":{"11":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}}}}}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{":":{"\\":{"df":0,"docs":{},"n":{"df":1,"docs":{"12":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{":":{"\\":{"df":0,"docs":{},"n":{"df":1,"docs":{"12":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"2":{"df":1,"docs":{"8":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"f":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"10":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":3,"docs":{"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0}}}}}}}}},"r":{"df":0,"docs":{},"r":{"(":{"\"":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":1,"docs":{"3":{"tf":1.0}}},"2":{"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"_":{"df":1,"docs":{"3":{"tf":1.4142135623730951}}},"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"x":{"<":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"5":{"tf":1.0}}}}}}}},"df":0,"docs":{}}}},"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"df":2,"docs":{"4":{"tf":1.4142135623730951},"5":{"tf":1.0}},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"b":{"a":{"df":0,"docs":{},"z":{"(":{"\"":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":3.1622776601683795},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":3.0},"5":{"tf":1.0},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":3.0},"9":{"tf":2.8284271247461903}},"e":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"m":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"\"":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":1,"docs":{"8":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"(":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{":":{":":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.0},"14":{"tf":3.0},"3":{"tf":1.0},"4":{"tf":3.0},"6":{"tf":3.0},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":2,"docs":{"3":{"tf":1.4142135623730951},"5":{"tf":1.0}},"o":{"df":0,"docs":{},"r":{":":{"\\":{"df":0,"docs":{},"n":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0}}}},"df":0,"docs":{}},"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":16,"docs":{"0":{"tf":2.0},"1":{"tf":3.872983346207417},"10":{"tf":8.246211251235321},"11":{"tf":8.306623862918075},"12":{"tf":8.246211251235321},"13":{"tf":8.602325267042627},"14":{"tf":8.54400374531753},"15":{"tf":1.0},"2":{"tf":1.4142135623730951},"3":{"tf":2.8284271247461903},"4":{"tf":8.18535277187245},"5":{"tf":1.4142135623730951},"6":{"tf":8.366600265340756},"7":{"tf":8.06225774829855},"8":{"tf":8.306623862918075},"9":{"tf":8.246211251235321}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"13":{"tf":1.0},"14":{"tf":1.0}}},"df":0,"docs":{}}}}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.4142135623730951},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":13,"docs":{"1":{"tf":1.7320508075688772},"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.6457513110645907},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"15":{"tf":1.0},"3":{"tf":1.7320508075688772},"4":{"tf":2.449489742783178},"6":{"tf":2.6457513110645907},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}},"e":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{":":{"1":{"3":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"2":{"0":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"4":{"5":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}},"f":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.4142135623730951}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.4142135623730951}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":1,"docs":{"11":{"tf":1.0}}}}}},"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.4142135623730951}}}}}},"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":1,"docs":{"8":{"tf":1.0}},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"0":{"tf":1.0}}}}}},"l":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.605551275463989},"11":{"tf":3.605551275463989},"12":{"tf":3.605551275463989},"13":{"tf":3.7416573867739413},"14":{"tf":3.872983346207417},"4":{"tf":3.605551275463989},"6":{"tf":3.605551275463989},"7":{"tf":3.605551275463989},"8":{"tf":3.605551275463989},"9":{"tf":3.605551275463989}},"e":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":11,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"2":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.4142135623730951},"9":{"tf":1.0}}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"5":{"tf":1.0},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":11,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"2":{"tf":1.0},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":13,"docs":{"1":{"tf":2.23606797749979},"10":{"tf":4.58257569495584},"11":{"tf":4.58257569495584},"12":{"tf":4.795831523312719},"13":{"tf":4.898979485566356},"14":{"tf":4.898979485566356},"2":{"tf":1.0},"4":{"tf":4.358898943540674},"5":{"tf":1.4142135623730951},"6":{"tf":4.358898943540674},"7":{"tf":4.58257569495584},"8":{"tf":4.69041575982343},"9":{"tf":4.58257569495584}}}},"df":0,"docs":{}}}},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"e":{":":{":":{"<":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"10":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"<":{"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"<":{"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.7320508075688772},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"t":{"df":1,"docs":{"7":{"tf":1.0}}},"x":{"df":1,"docs":{"14":{"tf":1.0}}}},"m":{"df":0,"docs":{},"t":{"(":{"&":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.1622776601683795},"14":{"tf":3.3166247903554},"4":{"tf":3.0},"6":{"tf":3.0},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"n":{"df":12,"docs":{"1":{"tf":2.6457513110645907},"10":{"tf":8.888194417315589},"11":{"tf":8.48528137423857},"12":{"tf":8.54400374531753},"13":{"tf":8.54400374531753},"14":{"tf":8.602325267042627},"3":{"tf":2.0},"4":{"tf":8.48528137423857},"6":{"tf":8.48528137423857},"7":{"tf":8.48528137423857},"8":{"tf":8.48528137423857},"9":{"tf":8.602325267042627}}},"o":{"df":0,"docs":{},"o":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.3166247903554},"11":{"tf":3.3166247903554},"12":{"tf":3.3166247903554},"13":{"tf":3.3166247903554},"14":{"tf":3.3166247903554},"4":{"tf":3.1622776601683795},"6":{"tf":3.1622776601683795},"7":{"tf":3.3166247903554},"8":{"tf":3.3166247903554},"9":{"tf":3.3166247903554}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"b":{"a":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"z":{"(":{"\"":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}}}}}}}},"r":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"!":{"(":{"\"":{"\\":{"df":0,"docs":{},"n":{"df":0,"docs":{},"{":{":":{"?":{"df":0,"docs":{},"}":{"\\":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"$":{"df":0,"docs":{},"v":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.4142135623730951},"8":{"tf":1.0},"9":{"tf":1.0}},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}}},"u":{"df":0,"docs":{},"n":{"c":{"(":{")":{".":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"w":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{")":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"1":{"df":12,"docs":{"1":{"tf":2.6457513110645907},"10":{"tf":5.0990195135927845},"11":{"tf":5.196152422706632},"12":{"tf":5.477225575051661},"13":{"tf":5.477225575051661},"14":{"tf":5.477225575051661},"3":{"tf":1.4142135623730951},"4":{"tf":5.196152422706632},"6":{"tf":5.477225575051661},"7":{"tf":5.0990195135927845},"8":{"tf":5.0990195135927845},"9":{"tf":5.0990195135927845}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}}}}}},":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":11,"docs":{"1":{"tf":1.7320508075688772},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":11,"docs":{"1":{"tf":1.7320508075688772},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":2.0},"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"(":{"\"":{"b":{"a":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"\"":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":3.4641016151377544},"14":{"tf":3.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}},"df":0,"docs":{}}}}}}}}}},"2":{"(":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"m":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"\"":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.7320508075688772},"8":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"|":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.4142135623730951},"6":{"tf":1.7320508075688772},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":13,"docs":{"1":{"tf":2.8284271247461903},"10":{"tf":3.872983346207417},"11":{"tf":3.872983346207417},"12":{"tf":4.0},"13":{"tf":4.242640687119285},"14":{"tf":4.47213595499958},"3":{"tf":1.4142135623730951},"4":{"tf":4.123105625617661},"5":{"tf":1.0},"6":{"tf":4.0},"7":{"tf":3.872983346207417},"8":{"tf":4.0},"9":{"tf":3.872983346207417}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},":":{"\\":{"df":0,"docs":{},"n":{"df":1,"docs":{"11":{"tf":1.0}}}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":1.7320508075688772},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}}},"3":{"(":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"m":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":2.0},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":3,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"3":{"tf":1.0}}}}}}},"df":0,"docs":{}}}},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":2,"docs":{"15":{"tf":1.0},"3":{"tf":1.0}}},"v":{"df":0,"docs":{},"e":{"df":2,"docs":{"10":{"tf":1.0},"14":{"tf":1.0}}}}}},"h":{"a":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"l":{"df":3,"docs":{"12":{"tf":1.0},"15":{"tf":1.0},"3":{"tf":1.0}}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"p":{"df":0,"docs":{},"i":{"df":1,"docs":{"15":{"tf":1.0}}}}},"r":{"d":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"p":{"df":1,"docs":{"4":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.4142135623730951}}}}}},"r":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.0},"5":{"tf":1.0}}}}},"i":{"d":{"df":0,"docs":{},"e":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.7320508075688772},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"p":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"i":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.605551275463989},"11":{"tf":3.605551275463989},"12":{"tf":3.605551275463989},"13":{"tf":3.7416573867739413},"14":{"tf":3.872983346207417},"4":{"tf":3.605551275463989},"6":{"tf":3.605551275463989},"7":{"tf":3.605551275463989},"8":{"tf":3.605551275463989},"9":{"tf":3.605551275463989}},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":11,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.23606797749979},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.23606797749979},"5":{"tf":1.0},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.449489742783178},"9":{"tf":2.23606797749979}}}}}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"v":{"df":2,"docs":{"14":{"tf":1.0},"3":{"tf":1.0}}}}}}},"n":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":3,"docs":{"0":{"tf":1.0},"3":{"tf":1.0},"7":{"tf":1.0}}}}}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":11,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"5":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":2,"docs":{"3":{"tf":1.0},"8":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"a":{"d":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"r":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"u":{"c":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"o":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{":":{":":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.23606797749979},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}}}}}}}},"s":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":1,"docs":{"15":{"tf":1.0}}}}}},"j":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"k":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"(":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}}}}}}}}},"<":{"'":{"a":{">":{"(":{"&":{"'":{"a":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.6457513110645907},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.8284271247461903},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.6457513110645907}}},"df":0,"docs":{}}}},"l":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"3":{"tf":1.0}}}},"z":{"df":0,"docs":{},"i":{"df":1,"docs":{"14":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"v":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{},"t":{"'":{"df":1,"docs":{"6":{"tf":1.0}}},"df":1,"docs":{"7":{"tf":1.0}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":13,"docs":{"0":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"2":{"tf":1.0},"4":{"tf":1.4142135623730951},"5":{"tf":1.7320508075688772},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.7320508075688772},"9":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":1,"docs":{"9":{"tf":1.0}}},"p":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"t":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"m":{"a":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}}},"r":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.449489742783178},"14":{"tf":2.23606797749979},"4":{"tf":2.449489742783178},"5":{"tf":1.0},"6":{"tf":2.23606797749979},"7":{"tf":2.449489742783178},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":12,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.1622776601683795},"11":{"tf":3.3166247903554},"12":{"tf":3.3166247903554},"13":{"tf":3.3166247903554},"14":{"tf":3.1622776601683795},"3":{"tf":1.4142135623730951},"4":{"tf":3.1622776601683795},"6":{"tf":3.3166247903554},"7":{"tf":3.1622776601683795},"8":{"tf":3.3166247903554},"9":{"tf":3.1622776601683795}}}},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":2,"docs":{"6":{"tf":1.0},"7":{"tf":1.0}}}}}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.4142135623730951},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"t":{"c":{"df":0,"docs":{},"h":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.3166247903554},"11":{"tf":3.3166247903554},"12":{"tf":3.4641016151377544},"13":{"tf":3.605551275463989},"14":{"tf":3.4641016151377544},"4":{"tf":3.1622776601683795},"6":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":3.1622776601683795},"9":{"tf":3.3166247903554}}}},"df":0,"docs":{}},"y":{"b":{"df":1,"docs":{"6":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"d":{"df":3,"docs":{"10":{"tf":1.0},"13":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}},"o":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"e":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}},"df":11,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":2.0},"13":{"tf":1.7320508075688772},"14":{"tf":2.0},"3":{"tf":1.0},"4":{"tf":1.7320508075688772},"6":{"tf":2.0},"7":{"tf":2.23606797749979},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"7":{"tf":1.4142135623730951}}}}}}}}}},"u":{"c":{"df":0,"docs":{},"h":{"df":1,"docs":{"14":{"tf":1.0}}}},"df":0,"docs":{},"t":{"a":{"b":{"df":0,"docs":{},"l":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":4.0},"11":{"tf":4.0},"12":{"tf":4.0},"13":{"tf":4.123105625617661},"14":{"tf":4.242640687119285},"4":{"tf":4.0},"6":{"tf":4.0},"7":{"tf":4.0},"8":{"tf":4.0},"9":{"tf":4.123105625617661}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":1,"docs":{"11":{"tf":1.0}}}}},"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.6457513110645907},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"5":{"tf":1.7320508075688772}}}}}}}},"x":{"df":0,"docs":{},"t":{"df":2,"docs":{"12":{"tf":1.0},"3":{"tf":1.0}}}}},"i":{"c":{"df":0,"docs":{},"e":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"4":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":10,"docs":{"10":{"tf":3.1622776601683795},"11":{"tf":3.1622776601683795},"12":{"tf":3.1622776601683795},"13":{"tf":3.1622776601683795},"14":{"tf":3.1622776601683795},"4":{"tf":3.1622776601683795},"6":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":3.1622776601683795},"9":{"tf":3.1622776601683795}}}},"t":{"df":0,"docs":{},"e":{"df":1,"docs":{"8":{"tf":1.0}}},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}}}},"i":{"c":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{}}},"w":{"df":6,"docs":{"0":{"tf":1.0},"11":{"tf":1.0},"13":{"tf":1.7320508075688772},"15":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.4142135623730951}}}},"u":{"df":0,"docs":{},"m":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"5":{"tf":1.4142135623730951},"8":{"tf":1.0}}}}},"df":0,"docs":{}}}},"o":{".":{"0":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"1":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"b":{"df":0,"docs":{},"j":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"9":{"tf":1.0}}}},"df":0,"docs":{}}}},"c":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"k":{"(":{"_":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}},"df":12,"docs":{"1":{"tf":2.0},"10":{"tf":5.5677643628300215},"11":{"tf":5.5677643628300215},"12":{"tf":5.656854249492381},"13":{"tf":5.5677643628300215},"14":{"tf":5.5677643628300215},"3":{"tf":1.7320508075688772},"4":{"tf":5.477225575051661},"6":{"tf":5.5677643628300215},"7":{"tf":5.5677643628300215},"8":{"tf":5.5677643628300215},"9":{"tf":5.5677643628300215}}},"l":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"5":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"n":{"df":1,"docs":{"14":{"tf":1.0}}},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"<":{"&":{"(":{"d":{"df":0,"docs":{},"y":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}},"df":0,"docs":{}},"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}},"u":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.449489742783178}}}}},"t":{"df":1,"docs":{"9":{"tf":1.0}}},"u":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"(":{"df":0,"docs":{},"u":{"3":{"2":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}},"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"x":{"<":{"d":{"df":0,"docs":{},"y":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"9":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"v":{"df":1,"docs":{"6":{"tf":1.0}}}}}}},"t":{"df":11,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"3":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.4142135623730951},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"p":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":5,"docs":{"1":{"tf":1.0},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.4142135623730951},"8":{"tf":1.0}}}}}}}},"p":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"c":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}},"df":0,"docs":{},"l":{"a":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"11":{"tf":1.0}}}},"df":0,"docs":{},"y":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"x":{"df":1,"docs":{"5":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"s":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}},"v":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":1,"docs":{"6":{"tf":1.0}}}}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":13,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"2":{"tf":1.4142135623730951},"3":{"tf":1.0},"4":{"tf":1.4142135623730951},"5":{"tf":1.0},"6":{"tf":1.7320508075688772},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}},"l":{"df":0,"docs":{},"n":{"df":1,"docs":{"7":{"tf":1.0}}}}}}},"o":{"b":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"14":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"v":{"df":0,"docs":{},"i":{"d":{"df":11,"docs":{"0":{"tf":1.4142135623730951},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}}},"u":{"b":{"df":10,"docs":{"10":{"tf":3.3166247903554},"11":{"tf":3.3166247903554},"12":{"tf":3.3166247903554},"13":{"tf":3.3166247903554},"14":{"tf":3.3166247903554},"4":{"tf":3.3166247903554},"6":{"tf":3.3166247903554},"7":{"tf":3.3166247903554},"8":{"tf":3.3166247903554},"9":{"tf":3.605551275463989}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":1,"docs":{"15":{"tf":1.0}}}}}},"q":{"df":2,"docs":{"1":{"tf":1.0},"3":{"tf":1.0}},"u":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"k":{"df":1,"docs":{"7":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"e":{"a":{"d":{"df":12,"docs":{"0":{"tf":1.0},"1":{"tf":2.0},"10":{"tf":3.872983346207417},"11":{"tf":3.872983346207417},"12":{"tf":4.0},"13":{"tf":4.123105625617661},"14":{"tf":4.123105625617661},"4":{"tf":3.7416573867739413},"6":{"tf":3.7416573867739413},"7":{"tf":3.872983346207417},"8":{"tf":3.872983346207417},"9":{"tf":3.872983346207417}}},"df":0,"docs":{},"l":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"l":{"df":1,"docs":{"4":{"tf":1.0}}},"p":{"df":0,"docs":{},"o":{"df":2,"docs":{"15":{"tf":1.0},"3":{"tf":1.0}},"r":{"df":0,"docs":{},"t":{"df":12,"docs":{"1":{"tf":2.23606797749979},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"15":{"tf":1.0},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"q":{"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"15":{"tf":1.0}}}}}}},"s":{"c":{"df":0,"docs":{},"u":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":13,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":5.0990195135927845},"11":{"tf":5.0990195135927845},"12":{"tf":5.196152422706632},"13":{"tf":5.0990195135927845},"14":{"tf":5.0},"3":{"tf":2.0},"4":{"tf":5.0990195135927845},"5":{"tf":1.0},"6":{"tf":5.0990195135927845},"7":{"tf":5.0990195135927845},"8":{"tf":5.0990195135927845},"9":{"tf":5.0990195135927845}}}}}},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":12,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.449489742783178},"3":{"tf":1.4142135623730951},"4":{"tf":2.449489742783178},"5":{"tf":1.7320508075688772},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.6457513110645907}}}}}}},"i":{"d":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":3,"docs":{"3":{"tf":1.0},"4":{"tf":1.0},"7":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"10":{"tf":1.0}},"e":{"(":{"&":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"u":{"df":0,"docs":{},"n":{"df":2,"docs":{"1":{"tf":1.0},"3":{"tf":1.7320508075688772}}},"s":{"df":0,"docs":{},"t":{",":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":11,"docs":{"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.1622776601683795},"13":{"tf":3.0},"14":{"tf":3.0},"3":{"tf":1.4142135623730951},"4":{"tf":3.0},"6":{"tf":3.1622776601683795},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}}}}}},"s":{".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"10":{"tf":1.4142135623730951}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"10":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":1,"docs":{"9":{"tf":1.0}}},"df":0,"docs":{}}}}}},"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"v":{"df":0,"docs":{},"e":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.4142135623730951},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.8284271247461903},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.23606797749979},"9":{"tf":2.449489742783178}},"e":{"df":0,"docs":{},"e":{"df":6,"docs":{"11":{"tf":1.4142135623730951},"12":{"tf":1.0},"3":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"8":{"tf":1.0}},"n":{"df":1,"docs":{"13":{"tf":1.0}}}},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"12":{"tf":1.0}}}},"df":0,"docs":{}},"f":{".":{"0":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"i":{"df":0,"docs":{},"s":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{":":{":":{"<":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"o":{"c":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":4.58257569495584},"11":{"tf":4.358898943540674},"12":{"tf":4.358898943540674},"13":{"tf":4.47213595499958},"14":{"tf":4.58257569495584},"4":{"tf":4.358898943540674},"6":{"tf":4.358898943540674},"7":{"tf":4.358898943540674},"8":{"tf":4.358898943540674},"9":{"tf":4.47213595499958}}}},"n":{"d":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":2,"docs":{"11":{"tf":1.0},"14":{"tf":1.0}}}}},"df":0,"docs":{}}},"w":{"df":1,"docs":{"3":{"tf":1.0}}}}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}}}},"m":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":2,"docs":{"14":{"tf":1.0},"4":{"tf":1.0}}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"v":{"df":1,"docs":{"12":{"tf":1.0}}}},"m":{"df":0,"docs":{},"e":{"(":{"&":{"*":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"(":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"x":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"(":{"$":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":2.0}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.8284271247461903},"11":{"tf":2.0},"12":{"tf":2.8284271247461903},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.23606797749979},"9":{"tf":2.0}},"e":{".":{"a":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"f":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":2.0}}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":2,"docs":{"10":{"tf":1.4142135623730951},"9":{"tf":1.0}}}}}}}}},"o":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"12":{"tf":1.0}}},"i":{"df":0,"docs":{},"m":{"df":1,"docs":{"8":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"r":{"c":{"df":13,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"15":{"tf":1.4142135623730951},"3":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.7320508075688772},"9":{"tf":1.4142135623730951}},"e":{"(":{"&":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}},"df":0,"docs":{}},"/":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"5":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"r":{"c":{"/":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"b":{".":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{":":{"1":{"5":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"2":{"0":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"2":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"4":{"7":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{".":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{":":{"1":{"6":{"df":1,"docs":{"6":{"tf":1.0}}},"9":{"df":1,"docs":{"6":{"tf":1.0}}},"df":0,"docs":{}},"3":{"5":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{}},"4":{"0":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"t":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"c":{">":{"(":{"&":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"9":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":6.48074069840786},"11":{"tf":6.164414002968976},"12":{"tf":6.164414002968976},"13":{"tf":6.164414002968976},"14":{"tf":6.164414002968976},"4":{"tf":6.164414002968976},"6":{"tf":6.164414002968976},"7":{"tf":6.164414002968976},"8":{"tf":6.164414002968976},"9":{"tf":6.244997998398398}}},"df":0,"docs":{}}}},"d":{":":{":":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"y":{":":{":":{"df":0,"docs":{},"t":{"df":0,"docs":{},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"i":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":1,"docs":{"8":{"tf":1.0}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":13,"docs":{"0":{"tf":1.0},"1":{"tf":1.0},"10":{"tf":3.605551275463989},"11":{"tf":3.4641016151377544},"12":{"tf":3.4641016151377544},"13":{"tf":3.605551275463989},"14":{"tf":3.4641016151377544},"3":{"tf":1.0},"4":{"tf":3.4641016151377544},"6":{"tf":3.4641016151377544},"7":{"tf":3.4641016151377544},"8":{"tf":3.4641016151377544},"9":{"tf":3.605551275463989}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"f":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{":":{":":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.7320508075688772},"3":{"tf":1.0},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"y":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.6457513110645907},"11":{"tf":2.6457513110645907},"12":{"tf":2.6457513110645907},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":2.6457513110645907},"6":{"tf":2.6457513110645907},"7":{"tf":2.6457513110645907},"8":{"tf":2.6457513110645907},"9":{"tf":2.6457513110645907}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.6457513110645907},"11":{"tf":2.6457513110645907},"12":{"tf":2.6457513110645907},"13":{"tf":2.8284271247461903},"14":{"tf":3.0},"4":{"tf":2.6457513110645907},"6":{"tf":2.6457513110645907},"7":{"tf":2.6457513110645907},"8":{"tf":2.6457513110645907},"9":{"tf":2.6457513110645907}}}}},"df":0,"docs":{}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.6457513110645907},"11":{"tf":2.6457513110645907},"12":{"tf":2.6457513110645907},"13":{"tf":2.8284271247461903},"14":{"tf":3.0},"4":{"tf":2.6457513110645907},"6":{"tf":2.6457513110645907},"7":{"tf":2.6457513110645907},"8":{"tf":2.6457513110645907},"9":{"tf":2.6457513110645907}}}}}}}},"{":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":1.7320508075688772},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.4142135623730951}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{":":{":":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.0},"14":{"tf":3.0},"3":{"tf":1.0},"4":{"tf":3.0},"6":{"tf":3.0},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{":":{":":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"<":{"df":0,"docs":{},"o":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"3":{"tf":1.0},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":13,"docs":{"0":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"2":{"tf":1.0},"4":{"tf":1.4142135623730951},"5":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"r":{"df":10,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"(":{"\"":{"b":{"a":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":5,"docs":{"11":{"tf":1.0},"13":{"tf":1.0},"3":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"7":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"(":{"\"":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"y":{"!":{"(":{"$":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"p":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"u":{"c":{"df":0,"docs":{},"t":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}},"u":{"b":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"15":{"tf":1.0}}}}}},"df":0,"docs":{}},"y":{"df":0,"docs":{},"n":{"c":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"x":{"df":1,"docs":{"7":{"tf":1.0}}}},"df":0,"docs":{}}}}},"t":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}}},":":{"df":0,"docs":{},"i":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}},"p":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":11,"docs":{"10":{"tf":3.3166247903554},"11":{"tf":3.1622776601683795},"12":{"tf":3.1622776601683795},"13":{"tf":3.3166247903554},"14":{"tf":3.1622776601683795},"4":{"tf":3.1622776601683795},"5":{"tf":1.0},"6":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":3.1622776601683795},"9":{"tf":3.3166247903554}},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"h":{"a":{"df":0,"docs":{},"t":{"'":{"df":1,"docs":{"15":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":1,"docs":{"9":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":1,"docs":{"7":{"tf":1.0}}}}}}}},"o":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"4":{"tf":1.0}}}}}}},"r":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":11,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"2":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"l":{"1":{"df":1,"docs":{"3":{"tf":1.0}}},"]":{"(":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"s":{":":{"/":{"/":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"l":{"d":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"u":{"b":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"/":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"/":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"l":{"1":{".":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"3":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":11,"docs":{"0":{"tf":1.4142135623730951},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}},"i":{"d":{":":{":":{"df":0,"docs":{},"o":{"df":0,"docs":{},"f":{":":{":":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"n":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"7":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"a":{"c":{"df":0,"docs":{},"h":{"df":10,"docs":{"10":{"tf":2.6457513110645907},"11":{"tf":2.6457513110645907},"12":{"tf":2.6457513110645907},"13":{"tf":2.6457513110645907},"14":{"tf":2.6457513110645907},"4":{"tf":2.6457513110645907},"6":{"tf":2.6457513110645907},"7":{"tf":2.6457513110645907},"8":{"tf":2.6457513110645907},"9":{"tf":2.6457513110645907}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"s":{"a":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}},"p":{"df":2,"docs":{"12":{"tf":1.0},"14":{"tf":1.0}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}}}},"s":{"df":13,"docs":{"0":{"tf":1.4142135623730951},"1":{"tf":2.0},"10":{"tf":6.855654600401044},"11":{"tf":6.6332495807108},"12":{"tf":6.6332495807108},"13":{"tf":7.0},"14":{"tf":6.6332495807108},"3":{"tf":1.7320508075688772},"4":{"tf":6.6332495807108},"6":{"tf":6.708203932499369},"7":{"tf":6.6332495807108},"8":{"tf":6.6332495807108},"9":{"tf":6.708203932499369}}}},"v":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}},"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":1,"docs":{"11":{"tf":1.0}}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"15":{"tf":1.0}}}}}}},"w":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":2,"docs":{"12":{"tf":1.0},"8":{"tf":1.0}}}},"y":{"df":2,"docs":{"12":{"tf":1.0},"3":{"tf":1.0}}}},"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"6":{"tf":1.0}}}}}}}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"0":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"!":{"(":{"df":0,"docs":{},"f":{"df":11,"docs":{"1":{"tf":1.7320508075688772},"10":{"tf":3.605551275463989},"11":{"tf":3.605551275463989},"12":{"tf":3.605551275463989},"13":{"tf":3.872983346207417},"14":{"tf":4.0},"4":{"tf":3.605551275463989},"6":{"tf":3.605551275463989},"7":{"tf":3.605551275463989},"8":{"tf":3.605551275463989},"9":{"tf":3.605551275463989}}}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"l":{"df":0,"docs":{},"n":{"!":{"(":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"breadcrumbs":{"root":{"_":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}},"o":{"c":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"a":{"d":{"d":{"df":2,"docs":{"3":{"tf":1.0},"7":{"tf":1.0}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{},"g":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":2,"docs":{"13":{"tf":1.0},"5":{"tf":1.0}}}}},"df":0,"docs":{}},"l":{"df":0,"docs":{},"i":{"a":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"(":{"d":{"df":0,"docs":{},"e":{"a":{"d":{"_":{"c":{"df":0,"docs":{},"o":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":12,"docs":{"0":{"tf":1.4142135623730951},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"5":{"tf":1.0},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"n":{"df":0,"docs":{},"y":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"p":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"5":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"6":{"tf":1.0}}}}}}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"!":{"(":{"df":0,"docs":{},"e":{".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"f":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{">":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{"(":{")":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"q":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"b":{"a":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"a":{"c":{"df":12,"docs":{"0":{"tf":2.0},"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"2":{"tf":1.4142135623730951},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.8284271247461903},"9":{"tf":2.449489742783178}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"df":1,"docs":{"12":{"tf":1.0}}}}}},"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}},"z":{"(":{"&":{"'":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"i":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}}},"l":{"df":0,"docs":{},"o":{"c":{"df":0,"docs":{},"k":{"df":1,"docs":{"3":{"tf":1.0}}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":1,"docs":{"15":{"tf":1.0}}},"l":{"df":10,"docs":{"10":{"tf":2.6457513110645907},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}}},"x":{"<":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":12,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":4.795831523312719},"11":{"tf":4.795831523312719},"12":{"tf":4.898979485566356},"13":{"tf":4.795831523312719},"14":{"tf":4.69041575982343},"3":{"tf":2.0},"4":{"tf":4.795831523312719},"6":{"tf":4.795831523312719},"7":{"tf":4.795831523312719},"8":{"tf":4.795831523312719},"9":{"tf":4.795831523312719}}}}}}},"s":{"df":0,"docs":{},"t":{"d":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"3":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}}}}}},"c":{".":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"9":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":11,"docs":{"1":{"tf":2.6457513110645907},"10":{"tf":3.0},"11":{"tf":2.8284271247461903},"12":{"tf":3.0},"13":{"tf":3.1622776601683795},"14":{"tf":3.4641016151377544},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"o":{"df":2,"docs":{"1":{"tf":1.0},"3":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"e":{"df":1,"docs":{"5":{"tf":1.0}}}},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":1,"docs":{"6":{"tf":1.0}}}}},"s":{"df":13,"docs":{"0":{"tf":1.0},"1":{"tf":2.23606797749979},"10":{"tf":5.196152422706632},"11":{"tf":5.0990195135927845},"12":{"tf":4.898979485566356},"13":{"tf":4.898979485566356},"14":{"tf":4.898979485566356},"2":{"tf":1.4142135623730951},"4":{"tf":4.898979485566356},"6":{"tf":4.898979485566356},"7":{"tf":4.898979485566356},"8":{"tf":5.0990195135927845},"9":{"tf":4.898979485566356}},"e":{".":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}},"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":2.23606797749979}},"f":{"df":0,"docs":{},"g":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":2.23606797749979},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"<":{"_":{">":{":":{":":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"(":{"$":{"df":0,"docs":{},"k":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"<":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}}},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":3,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"5":{"tf":1.0}}}}},"t":{">":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":4.898979485566356},"11":{"tf":4.898979485566356},"12":{"tf":4.795831523312719},"13":{"tf":4.898979485566356},"14":{"tf":4.795831523312719},"4":{"tf":4.795831523312719},"5":{"tf":1.4142135623730951},"6":{"tf":4.795831523312719},"7":{"tf":4.795831523312719},"8":{"tf":4.795831523312719},"9":{"tf":4.795831523312719}}},"u":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}}},"df":13,"docs":{"0":{"tf":2.449489742783178},"1":{"tf":1.0},"10":{"tf":3.1622776601683795},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.0},"14":{"tf":3.0},"3":{"tf":1.4142135623730951},"4":{"tf":3.1622776601683795},"6":{"tf":3.0},"7":{"tf":3.1622776601683795},"8":{"tf":3.3166247903554},"9":{"tf":3.0}}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"<":{"df":0,"docs":{},"o":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.8284271247461903},"14":{"tf":2.6457513110645907},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}}}}}}}}},"n":{"df":0,"docs":{},"g":{"df":3,"docs":{"4":{"tf":1.0},"6":{"tf":1.0},"8":{"tf":1.0}}}},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"12":{"tf":1.0},"3":{"tf":1.0}}}}}},"r":{"df":1,"docs":{"7":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"k":{"df":1,"docs":{"3":{"tf":1.0}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.3166247903554},"14":{"tf":3.3166247903554},"4":{"tf":3.0},"6":{"tf":3.3166247903554},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}},"o":{"df":0,"docs":{},"l":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"5":{"tf":1.0}}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":11,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.0},"14":{"tf":1.7320508075688772},"4":{"tf":2.0},"5":{"tf":1.0},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"6":{"tf":1.0}}}},"o":{"d":{"df":0,"docs":{},"e":{"df":4,"docs":{"12":{"tf":1.0},"15":{"tf":1.0},"3":{"tf":1.0},"7":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.4142135623730951}}},"p":{"a":{"df":0,"docs":{},"r":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":11,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"2":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"n":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"u":{"df":1,"docs":{"0":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":1,"docs":{"6":{"tf":1.0}}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}}}},"p":{"df":0,"docs":{},"e":{"df":1,"docs":{"13":{"tf":1.0}}}},"r":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"4":{"tf":1.0}}}}}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":1,"docs":{"10":{"tf":1.0}}}}}},"r":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{":":{":":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"4":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}},"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{"(":{"&":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},">":{"(":{"&":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":3.4641016151377544},"11":{"tf":3.1622776601683795},"12":{"tf":3.1622776601683795},"13":{"tf":3.1622776601683795},"14":{"tf":3.1622776601683795},"4":{"tf":3.1622776601683795},"6":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":3.1622776601683795},"9":{"tf":3.1622776601683795}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":14,"docs":{"0":{"tf":1.7320508075688772},"1":{"tf":1.0},"10":{"tf":3.872983346207417},"11":{"tf":3.872983346207417},"12":{"tf":3.872983346207417},"13":{"tf":4.0},"14":{"tf":4.58257569495584},"2":{"tf":1.4142135623730951},"4":{"tf":4.0},"5":{"tf":1.4142135623730951},"6":{"tf":4.123105625617661},"7":{"tf":4.0},"8":{"tf":4.0},"9":{"tf":3.872983346207417}}}}},"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"7":{"tf":1.0}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.4142135623730951},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":1,"docs":{"13":{"tf":1.0}},"e":{"(":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.0},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"_":{"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.23606797749979},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}}}}}}}},"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.23606797749979},"11":{"tf":2.6457513110645907},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}}},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"y":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{"(":{"&":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":13,"docs":{"0":{"tf":1.0},"10":{"tf":5.744562646538029},"11":{"tf":5.477225575051661},"12":{"tf":5.477225575051661},"13":{"tf":5.5677643628300215},"14":{"tf":5.5677643628300215},"2":{"tf":1.4142135623730951},"3":{"tf":1.0},"4":{"tf":5.477225575051661},"6":{"tf":5.5677643628300215},"7":{"tf":5.477225575051661},"8":{"tf":5.744562646538029},"9":{"tf":5.477225575051661}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"u":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}}}}}},"o":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"_":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"(":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"m":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"\"":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.0},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}}}}}}}},"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"|":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.4142135623730951},"6":{"tf":1.7320508075688772},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":13,"docs":{"1":{"tf":1.0},"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"3":{"tf":1.4142135623730951},"4":{"tf":3.0},"5":{"tf":1.0},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"(":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}}},"df":0,"docs":{}}}}}},"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"13":{"tf":1.0},"14":{"tf":1.0},"3":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"n":{"'":{"df":0,"docs":{},"t":{"df":1,"docs":{"14":{"tf":1.0}}}},"df":0,"docs":{}}}},"n":{"'":{"df":0,"docs":{},"t":{"df":1,"docs":{"8":{"tf":1.0}}}},"df":0,"docs":{}},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":1,"docs":{"10":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"<":{"df":0,"docs":{},"t":{"df":1,"docs":{"9":{"tf":1.0}}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"<":{"df":0,"docs":{},"t":{"df":1,"docs":{"9":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":2.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"y":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":3.0}}}}},"df":0,"docs":{},"e":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},".":{"a":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":1,"docs":{"9":{"tf":1.0}}}}}},"df":0,"docs":{}}},"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":1,"docs":{"12":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":1,"docs":{"10":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{">":{"(":{")":{".":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"w":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"p":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":1,"docs":{"8":{"tf":1.0}}},"df":0,"docs":{}}}}}},":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"i":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}},"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":1,"docs":{"3":{"tf":1.0}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":4.123105625617661},"11":{"tf":4.0},"12":{"tf":4.0},"13":{"tf":4.242640687119285},"14":{"tf":4.242640687119285},"4":{"tf":4.0},"6":{"tf":4.123105625617661},"7":{"tf":4.123105625617661},"8":{"tf":4.123105625617661},"9":{"tf":4.123105625617661}},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"12":{"tf":1.0}}}}}}},"df":0,"docs":{}}}},"n":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"8":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"c":{"a":{"df":0,"docs":{},"p":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"d":{"df":3,"docs":{"12":{"tf":1.0},"14":{"tf":1.4142135623730951},"15":{"tf":1.4142135623730951}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.8284271247461903},"14":{"tf":2.449489742783178},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"n":{"!":{"(":{"\"":{"\\":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"t":{"df":0,"docs":{},"h":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":1,"docs":{"11":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}}}}}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{":":{"\\":{"df":0,"docs":{},"n":{"df":1,"docs":{"12":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{":":{"\\":{"df":0,"docs":{},"n":{"df":1,"docs":{"12":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"2":{"df":1,"docs":{"8":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"f":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"10":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":3,"docs":{"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0}}}}}}}}},"r":{"df":0,"docs":{},"r":{"(":{"\"":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":1,"docs":{"3":{"tf":1.0}}},"2":{"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"_":{"df":1,"docs":{"3":{"tf":1.4142135623730951}}},"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"x":{"<":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"5":{"tf":1.0}}}}}}}},"df":0,"docs":{}}}},"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"df":2,"docs":{"4":{"tf":1.4142135623730951},"5":{"tf":1.0}},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"b":{"a":{"df":0,"docs":{},"z":{"(":{"\"":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":3.1622776601683795},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":3.0},"5":{"tf":1.0},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":3.0},"9":{"tf":2.8284271247461903}},"e":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"m":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"\"":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":1,"docs":{"8":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"(":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{":":{":":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.0},"14":{"tf":3.0},"3":{"tf":1.0},"4":{"tf":3.0},"6":{"tf":3.0},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":2,"docs":{"3":{"tf":1.4142135623730951},"5":{"tf":1.0}},"o":{"df":0,"docs":{},"r":{":":{"\\":{"df":0,"docs":{},"n":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0}}}},"df":0,"docs":{}},"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":16,"docs":{"0":{"tf":2.0},"1":{"tf":3.872983346207417},"10":{"tf":8.306623862918075},"11":{"tf":8.366600265340756},"12":{"tf":8.306623862918075},"13":{"tf":8.602325267042627},"14":{"tf":8.54400374531753},"15":{"tf":1.0},"2":{"tf":1.4142135623730951},"3":{"tf":3.0},"4":{"tf":8.246211251235321},"5":{"tf":1.4142135623730951},"6":{"tf":8.426149773176359},"7":{"tf":8.06225774829855},"8":{"tf":8.366600265340756},"9":{"tf":8.306623862918075}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.4142135623730951},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":13,"docs":{"1":{"tf":2.0},"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.6457513110645907},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"15":{"tf":1.0},"3":{"tf":1.7320508075688772},"4":{"tf":2.449489742783178},"6":{"tf":2.6457513110645907},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}},"e":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{":":{"1":{"3":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"2":{"0":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"4":{"5":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}},"f":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.4142135623730951}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.4142135623730951}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":1,"docs":{"11":{"tf":1.0}}}}}},"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.4142135623730951}}}}}},"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":1,"docs":{"8":{"tf":1.0}},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"0":{"tf":1.0}}}}}},"l":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.605551275463989},"11":{"tf":3.605551275463989},"12":{"tf":3.605551275463989},"13":{"tf":3.7416573867739413},"14":{"tf":3.872983346207417},"4":{"tf":3.605551275463989},"6":{"tf":3.605551275463989},"7":{"tf":3.605551275463989},"8":{"tf":3.605551275463989},"9":{"tf":3.605551275463989}},"e":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":11,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"2":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.4142135623730951},"9":{"tf":1.0}}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"5":{"tf":1.0},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":11,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"2":{"tf":1.0},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":13,"docs":{"1":{"tf":2.23606797749979},"10":{"tf":4.58257569495584},"11":{"tf":4.58257569495584},"12":{"tf":4.795831523312719},"13":{"tf":4.898979485566356},"14":{"tf":4.898979485566356},"2":{"tf":1.0},"4":{"tf":4.358898943540674},"5":{"tf":1.4142135623730951},"6":{"tf":4.358898943540674},"7":{"tf":4.58257569495584},"8":{"tf":4.69041575982343},"9":{"tf":4.58257569495584}}}},"df":0,"docs":{}}}},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"e":{":":{":":{"<":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"10":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"<":{"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"<":{"df":0,"docs":{},"u":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":2.0},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"t":{"df":1,"docs":{"7":{"tf":1.0}}},"x":{"df":1,"docs":{"14":{"tf":1.0}}}},"m":{"df":0,"docs":{},"t":{"(":{"&":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.1622776601683795},"14":{"tf":3.3166247903554},"4":{"tf":3.0},"6":{"tf":3.0},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"n":{"df":12,"docs":{"1":{"tf":2.6457513110645907},"10":{"tf":8.888194417315589},"11":{"tf":8.48528137423857},"12":{"tf":8.54400374531753},"13":{"tf":8.54400374531753},"14":{"tf":8.602325267042627},"3":{"tf":2.0},"4":{"tf":8.48528137423857},"6":{"tf":8.48528137423857},"7":{"tf":8.48528137423857},"8":{"tf":8.48528137423857},"9":{"tf":8.602325267042627}}},"o":{"df":0,"docs":{},"o":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.3166247903554},"11":{"tf":3.3166247903554},"12":{"tf":3.3166247903554},"13":{"tf":3.3166247903554},"14":{"tf":3.3166247903554},"4":{"tf":3.1622776601683795},"6":{"tf":3.1622776601683795},"7":{"tf":3.3166247903554},"8":{"tf":3.3166247903554},"9":{"tf":3.3166247903554}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"b":{"a":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"z":{"(":{"\"":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}}}}}}}},"r":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"!":{"(":{"\"":{"\\":{"df":0,"docs":{},"n":{"df":0,"docs":{},"{":{":":{"?":{"df":0,"docs":{},"}":{"\\":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"$":{"df":0,"docs":{},"v":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.4142135623730951},"8":{"tf":1.0},"9":{"tf":1.0}},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}}},"u":{"df":0,"docs":{},"n":{"c":{"(":{")":{".":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"w":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{")":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"1":{"df":12,"docs":{"1":{"tf":2.6457513110645907},"10":{"tf":5.0990195135927845},"11":{"tf":5.196152422706632},"12":{"tf":5.477225575051661},"13":{"tf":5.477225575051661},"14":{"tf":5.477225575051661},"3":{"tf":1.4142135623730951},"4":{"tf":5.196152422706632},"6":{"tf":5.477225575051661},"7":{"tf":5.0990195135927845},"8":{"tf":5.0990195135927845},"9":{"tf":5.0990195135927845}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}}}}}},":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":11,"docs":{"1":{"tf":1.7320508075688772},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":11,"docs":{"1":{"tf":1.7320508075688772},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":2.0},"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"df":1,"docs":{"12":{"tf":1.0}}}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{"(":{"\"":{"b":{"a":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"\"":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":3.4641016151377544},"14":{"tf":3.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}},"df":0,"docs":{}}}}}}}}}},"2":{"(":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"m":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"\"":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.7320508075688772},"8":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"|":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.4142135623730951},"6":{"tf":1.7320508075688772},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":13,"docs":{"1":{"tf":2.8284271247461903},"10":{"tf":3.872983346207417},"11":{"tf":3.872983346207417},"12":{"tf":4.0},"13":{"tf":4.242640687119285},"14":{"tf":4.47213595499958},"3":{"tf":1.4142135623730951},"4":{"tf":4.123105625617661},"5":{"tf":1.0},"6":{"tf":4.0},"7":{"tf":3.872983346207417},"8":{"tf":4.0},"9":{"tf":3.872983346207417}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},":":{"\\":{"df":0,"docs":{},"n":{"df":1,"docs":{"11":{"tf":1.0}}}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":1.7320508075688772},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}}},"3":{"(":{")":{".":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"(":{"df":0,"docs":{},"m":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"!":{"(":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":2.0},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":3,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"3":{"tf":1.0}}}}}}},"df":0,"docs":{}}}},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":2,"docs":{"15":{"tf":1.0},"3":{"tf":1.0}}},"v":{"df":0,"docs":{},"e":{"df":2,"docs":{"10":{"tf":1.0},"14":{"tf":1.0}}}}}},"h":{"a":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"l":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"15":{"tf":1.0},"3":{"tf":1.0}}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"p":{"df":0,"docs":{},"i":{"df":1,"docs":{"15":{"tf":1.0}}}}},"r":{"d":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"p":{"df":1,"docs":{"4":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.4142135623730951}}}}}},"r":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.0},"5":{"tf":1.4142135623730951}}}}},"i":{"d":{"df":0,"docs":{},"e":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.7320508075688772},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"p":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"i":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.605551275463989},"11":{"tf":3.605551275463989},"12":{"tf":3.605551275463989},"13":{"tf":3.7416573867739413},"14":{"tf":3.872983346207417},"4":{"tf":3.605551275463989},"6":{"tf":3.605551275463989},"7":{"tf":3.605551275463989},"8":{"tf":3.605551275463989},"9":{"tf":3.605551275463989}},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":11,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.23606797749979},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.23606797749979},"5":{"tf":1.0},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.449489742783178},"9":{"tf":2.23606797749979}}}}}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"v":{"df":2,"docs":{"14":{"tf":1.0},"3":{"tf":1.0}}}}}}},"n":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":3,"docs":{"0":{"tf":1.0},"3":{"tf":1.0},"7":{"tf":1.0}}}}}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":11,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"5":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":2,"docs":{"3":{"tf":1.0},"8":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"a":{"d":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"r":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"u":{"c":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"o":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{":":{":":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.23606797749979},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}}}}}}}},"s":{"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":1,"docs":{"15":{"tf":1.0}}}}}},"j":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"k":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"(":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}}}}}}}}},"<":{"'":{"a":{">":{"(":{"&":{"'":{"a":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.6457513110645907},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.8284271247461903},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.6457513110645907}}},"df":0,"docs":{}}}},"l":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"3":{"tf":1.0}}}},"z":{"df":0,"docs":{},"i":{"df":1,"docs":{"14":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"v":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{},"t":{"'":{"df":1,"docs":{"6":{"tf":1.0}}},"df":1,"docs":{"7":{"tf":1.0}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":13,"docs":{"0":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"2":{"tf":1.0},"4":{"tf":1.4142135623730951},"5":{"tf":1.7320508075688772},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.7320508075688772},"9":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":1,"docs":{"9":{"tf":1.0}}},"p":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"t":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"m":{"a":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}}},"r":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.449489742783178},"14":{"tf":2.23606797749979},"4":{"tf":2.449489742783178},"5":{"tf":1.0},"6":{"tf":2.23606797749979},"7":{"tf":2.449489742783178},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":12,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.1622776601683795},"11":{"tf":3.3166247903554},"12":{"tf":3.3166247903554},"13":{"tf":3.3166247903554},"14":{"tf":3.1622776601683795},"3":{"tf":1.4142135623730951},"4":{"tf":3.1622776601683795},"6":{"tf":3.3166247903554},"7":{"tf":3.1622776601683795},"8":{"tf":3.3166247903554},"9":{"tf":3.1622776601683795}}}},"p":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":2,"docs":{"6":{"tf":1.0},"7":{"tf":1.0}}}}}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.7320508075688772},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"t":{"c":{"df":0,"docs":{},"h":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":3.3166247903554},"11":{"tf":3.3166247903554},"12":{"tf":3.4641016151377544},"13":{"tf":3.605551275463989},"14":{"tf":3.4641016151377544},"4":{"tf":3.1622776601683795},"6":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":3.1622776601683795},"9":{"tf":3.3166247903554}}}},"df":0,"docs":{}},"y":{"b":{"df":1,"docs":{"6":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"d":{"df":3,"docs":{"10":{"tf":1.0},"13":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}},"o":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"e":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}},"df":11,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":2.0},"13":{"tf":1.7320508075688772},"14":{"tf":2.0},"3":{"tf":1.0},"4":{"tf":1.7320508075688772},"6":{"tf":2.0},"7":{"tf":2.23606797749979},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"7":{"tf":1.4142135623730951}}}}}}}}}},"u":{"c":{"df":0,"docs":{},"h":{"df":1,"docs":{"14":{"tf":1.0}}}},"df":0,"docs":{},"t":{"a":{"b":{"df":0,"docs":{},"l":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":4.0},"11":{"tf":4.0},"12":{"tf":4.0},"13":{"tf":4.123105625617661},"14":{"tf":4.242640687119285},"4":{"tf":4.0},"6":{"tf":4.0},"7":{"tf":4.0},"8":{"tf":4.0},"9":{"tf":4.123105625617661}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":1,"docs":{"11":{"tf":1.0}}}}},"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.6457513110645907},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"5":{"tf":1.7320508075688772}}}}}}}},"x":{"df":0,"docs":{},"t":{"df":2,"docs":{"12":{"tf":1.0},"3":{"tf":1.0}}}}},"i":{"c":{"df":0,"docs":{},"e":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"4":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":10,"docs":{"10":{"tf":3.1622776601683795},"11":{"tf":3.1622776601683795},"12":{"tf":3.1622776601683795},"13":{"tf":3.1622776601683795},"14":{"tf":3.1622776601683795},"4":{"tf":3.1622776601683795},"6":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":3.1622776601683795},"9":{"tf":3.1622776601683795}}}},"t":{"df":0,"docs":{},"e":{"df":1,"docs":{"8":{"tf":1.0}}},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}}}},"i":{"c":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{}}},"w":{"df":6,"docs":{"0":{"tf":1.0},"11":{"tf":1.0},"13":{"tf":1.7320508075688772},"15":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.4142135623730951}}}},"u":{"df":0,"docs":{},"m":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"5":{"tf":1.4142135623730951},"8":{"tf":1.0}}}}},"df":0,"docs":{}}}},"o":{".":{"0":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"1":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"b":{"df":0,"docs":{},"j":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"9":{"tf":1.0}}}},"df":0,"docs":{}}}},"c":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"k":{"(":{"_":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}},"df":12,"docs":{"1":{"tf":2.0},"10":{"tf":5.5677643628300215},"11":{"tf":5.5677643628300215},"12":{"tf":5.656854249492381},"13":{"tf":5.5677643628300215},"14":{"tf":5.5677643628300215},"3":{"tf":1.7320508075688772},"4":{"tf":5.477225575051661},"6":{"tf":5.5677643628300215},"7":{"tf":5.5677643628300215},"8":{"tf":5.5677643628300215},"9":{"tf":5.5677643628300215}}},"l":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"5":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"n":{"df":1,"docs":{"14":{"tf":1.0}}},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"<":{"&":{"(":{"d":{"df":0,"docs":{},"y":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.0},"12":{"tf":2.0},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.0},"9":{"tf":2.0}}}}},"df":0,"docs":{}},"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}}},"u":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.449489742783178}}}}},"t":{"df":1,"docs":{"9":{"tf":1.0}}},"u":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"(":{"df":0,"docs":{},"u":{"3":{"2":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}},"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"x":{"<":{"d":{"df":0,"docs":{},"y":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"9":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"v":{"df":1,"docs":{"6":{"tf":1.0}}}}}}},"t":{"df":11,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"3":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.4142135623730951},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"p":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":5,"docs":{"1":{"tf":1.0},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.4142135623730951},"8":{"tf":1.0}}}}}}}},"p":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"c":{"df":10,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.449489742783178},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"4":{"tf":2.449489742783178},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.449489742783178}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}},"df":0,"docs":{},"l":{"a":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"11":{"tf":1.0}}}},"df":0,"docs":{},"y":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"x":{"df":1,"docs":{"5":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"s":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}},"v":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":1,"docs":{"6":{"tf":1.0}}}}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":13,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"2":{"tf":1.4142135623730951},"3":{"tf":1.0},"4":{"tf":1.4142135623730951},"5":{"tf":1.0},"6":{"tf":1.7320508075688772},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}},"l":{"df":0,"docs":{},"n":{"df":1,"docs":{"7":{"tf":1.0}}}}}}},"o":{"b":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"14":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"v":{"df":0,"docs":{},"i":{"d":{"df":11,"docs":{"0":{"tf":1.4142135623730951},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}}},"u":{"b":{"df":10,"docs":{"10":{"tf":3.3166247903554},"11":{"tf":3.3166247903554},"12":{"tf":3.3166247903554},"13":{"tf":3.3166247903554},"14":{"tf":3.3166247903554},"4":{"tf":3.3166247903554},"6":{"tf":3.3166247903554},"7":{"tf":3.3166247903554},"8":{"tf":3.3166247903554},"9":{"tf":3.605551275463989}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":1,"docs":{"15":{"tf":1.0}}}}}},"q":{"df":2,"docs":{"1":{"tf":1.0},"3":{"tf":1.0}},"u":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"k":{"df":1,"docs":{"7":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}},"e":{"a":{"d":{"df":12,"docs":{"0":{"tf":1.0},"1":{"tf":2.0},"10":{"tf":3.872983346207417},"11":{"tf":3.872983346207417},"12":{"tf":4.0},"13":{"tf":4.123105625617661},"14":{"tf":4.123105625617661},"4":{"tf":3.7416573867739413},"6":{"tf":3.7416573867739413},"7":{"tf":3.872983346207417},"8":{"tf":3.872983346207417},"9":{"tf":3.872983346207417}}},"df":0,"docs":{},"l":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"l":{"df":1,"docs":{"4":{"tf":1.0}}},"p":{"df":0,"docs":{},"o":{"df":2,"docs":{"15":{"tf":1.0},"3":{"tf":1.0}},"r":{"df":0,"docs":{},"t":{"df":12,"docs":{"1":{"tf":2.23606797749979},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":2.449489742783178},"14":{"tf":2.449489742783178},"15":{"tf":1.0},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"q":{"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"15":{"tf":1.0}}}}}}},"s":{"c":{"df":0,"docs":{},"u":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":13,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":5.0990195135927845},"11":{"tf":5.0990195135927845},"12":{"tf":5.196152422706632},"13":{"tf":5.0990195135927845},"14":{"tf":5.0},"3":{"tf":2.0},"4":{"tf":5.0990195135927845},"5":{"tf":1.0},"6":{"tf":5.0990195135927845},"7":{"tf":5.0990195135927845},"8":{"tf":5.0990195135927845},"9":{"tf":5.0990195135927845}}}}}},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":12,"docs":{"10":{"tf":2.449489742783178},"11":{"tf":2.449489742783178},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.449489742783178},"3":{"tf":1.4142135623730951},"4":{"tf":2.449489742783178},"5":{"tf":1.7320508075688772},"6":{"tf":2.449489742783178},"7":{"tf":2.449489742783178},"8":{"tf":2.449489742783178},"9":{"tf":2.6457513110645907}}}}}}},"i":{"d":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":3,"docs":{"3":{"tf":1.0},"4":{"tf":1.0},"7":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"10":{"tf":1.0}},"e":{"(":{"&":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.23606797749979},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"u":{"df":0,"docs":{},"n":{"df":2,"docs":{"1":{"tf":1.0},"3":{"tf":1.7320508075688772}}},"s":{"df":0,"docs":{},"t":{",":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"df":11,"docs":{"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.1622776601683795},"13":{"tf":3.0},"14":{"tf":3.0},"3":{"tf":1.4142135623730951},"4":{"tf":3.0},"6":{"tf":3.1622776601683795},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}}}}}},"s":{".":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{":":{":":{"<":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"10":{"tf":1.4142135623730951}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"10":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":1,"docs":{"9":{"tf":1.0}}},"df":0,"docs":{}}}}}},"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"v":{"df":0,"docs":{},"e":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.7320508075688772},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":2.0},"12":{"tf":2.8284271247461903},"13":{"tf":2.0},"14":{"tf":2.0},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.23606797749979},"9":{"tf":2.449489742783178}},"e":{"df":0,"docs":{},"e":{"df":6,"docs":{"11":{"tf":1.4142135623730951},"12":{"tf":1.0},"3":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"8":{"tf":1.0}},"n":{"df":1,"docs":{"13":{"tf":1.0}}}},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"12":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"f":{".":{"0":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"_":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"i":{"df":0,"docs":{},"s":{":":{":":{"<":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"_":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{":":{":":{"<":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"o":{"c":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":4.58257569495584},"11":{"tf":4.358898943540674},"12":{"tf":4.358898943540674},"13":{"tf":4.47213595499958},"14":{"tf":4.58257569495584},"4":{"tf":4.358898943540674},"6":{"tf":4.358898943540674},"7":{"tf":4.358898943540674},"8":{"tf":4.358898943540674},"9":{"tf":4.47213595499958}}}},"n":{"d":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":2,"docs":{"11":{"tf":1.0},"14":{"tf":1.0}}}}},"df":0,"docs":{}}},"w":{"df":1,"docs":{"3":{"tf":1.0}}}}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":2,"docs":{"3":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951}}}}}},"m":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":2,"docs":{"14":{"tf":1.0},"4":{"tf":1.0}}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"v":{"df":1,"docs":{"12":{"tf":1.0}}}},"m":{"df":0,"docs":{},"e":{"(":{"&":{"*":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"(":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}}},"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"x":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"(":{"$":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":2.0}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.8284271247461903},"11":{"tf":2.0},"12":{"tf":2.8284271247461903},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.0},"6":{"tf":2.0},"7":{"tf":2.0},"8":{"tf":2.23606797749979},"9":{"tf":2.0}},"e":{".":{"a":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"f":{"1":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"2":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":2.0}}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":2,"docs":{"10":{"tf":1.4142135623730951},"9":{"tf":1.0}}}}}}}}},"o":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"12":{"tf":1.0}}},"i":{"df":0,"docs":{},"m":{"df":1,"docs":{"8":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"r":{"c":{"df":13,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"15":{"tf":1.4142135623730951},"3":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":2.0},"9":{"tf":1.4142135623730951}},"e":{"(":{"&":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}},"df":0,"docs":{}},"/":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"5":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"r":{"c":{"/":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"b":{".":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{":":{"1":{"5":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"2":{"0":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}},"2":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"4":{"7":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{".":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{":":{"1":{"6":{"df":1,"docs":{"6":{"tf":1.0}}},"9":{"df":1,"docs":{"6":{"tf":1.0}}},"df":0,"docs":{}},"3":{"5":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{}},"4":{"0":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"t":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"c":{">":{"(":{"&":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"9":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":2.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":6.48074069840786},"11":{"tf":6.164414002968976},"12":{"tf":6.164414002968976},"13":{"tf":6.164414002968976},"14":{"tf":6.164414002968976},"4":{"tf":6.164414002968976},"6":{"tf":6.164414002968976},"7":{"tf":6.164414002968976},"8":{"tf":6.164414002968976},"9":{"tf":6.244997998398398}}},"df":0,"docs":{}}}},"d":{":":{":":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"y":{":":{":":{"df":0,"docs":{},"t":{"df":0,"docs":{},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"i":{"d":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{":":{":":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":1,"docs":{"8":{"tf":1.0}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":13,"docs":{"0":{"tf":1.0},"1":{"tf":1.0},"10":{"tf":3.605551275463989},"11":{"tf":3.4641016151377544},"12":{"tf":3.4641016151377544},"13":{"tf":3.605551275463989},"14":{"tf":3.4641016151377544},"3":{"tf":1.0},"4":{"tf":3.4641016151377544},"6":{"tf":3.4641016151377544},"7":{"tf":3.4641016151377544},"8":{"tf":3.4641016151377544},"9":{"tf":3.605551275463989}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"f":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{":":{":":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.7320508075688772},"3":{"tf":1.0},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"y":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":2.6457513110645907},"11":{"tf":2.6457513110645907},"12":{"tf":2.6457513110645907},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":2.6457513110645907},"6":{"tf":2.6457513110645907},"7":{"tf":2.6457513110645907},"8":{"tf":2.6457513110645907},"9":{"tf":2.6457513110645907}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.6457513110645907},"11":{"tf":2.6457513110645907},"12":{"tf":2.6457513110645907},"13":{"tf":2.8284271247461903},"14":{"tf":3.0},"4":{"tf":2.6457513110645907},"6":{"tf":2.6457513110645907},"7":{"tf":2.6457513110645907},"8":{"tf":2.6457513110645907},"9":{"tf":2.6457513110645907}}}}},"df":0,"docs":{}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":2.6457513110645907},"11":{"tf":2.6457513110645907},"12":{"tf":2.6457513110645907},"13":{"tf":2.8284271247461903},"14":{"tf":3.0},"4":{"tf":2.6457513110645907},"6":{"tf":2.6457513110645907},"7":{"tf":2.6457513110645907},"8":{"tf":2.6457513110645907},"9":{"tf":2.6457513110645907}}}}}}}},"{":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"o":{":":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":11,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":1.7320508075688772},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.4142135623730951}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{":":{":":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"10":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":3.0},"14":{"tf":3.0},"3":{"tf":1.0},"4":{"tf":3.0},"6":{"tf":3.0},"7":{"tf":3.0},"8":{"tf":3.0},"9":{"tf":3.0}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{":":{":":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"<":{"df":0,"docs":{},"o":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":12,"docs":{"1":{"tf":1.0},"10":{"tf":2.8284271247461903},"11":{"tf":2.8284271247461903},"12":{"tf":2.8284271247461903},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"3":{"tf":1.0},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":13,"docs":{"0":{"tf":1.0},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"2":{"tf":1.0},"4":{"tf":1.4142135623730951},"5":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"r":{"df":10,"docs":{"10":{"tf":2.23606797749979},"11":{"tf":2.23606797749979},"12":{"tf":2.23606797749979},"13":{"tf":2.23606797749979},"14":{"tf":2.23606797749979},"4":{"tf":2.23606797749979},"6":{"tf":2.23606797749979},"7":{"tf":2.23606797749979},"8":{"tf":2.23606797749979},"9":{"tf":2.23606797749979}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{":":{":":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"(":{"\"":{"b":{"a":{"df":0,"docs":{},"r":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"df":11,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":5,"docs":{"11":{"tf":1.0},"13":{"tf":1.0},"3":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"7":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"(":{"\"":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"c":{"1":{"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"y":{"!":{"(":{"$":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"p":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"u":{"c":{"df":0,"docs":{},"t":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.7320508075688772},"11":{"tf":2.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}},"u":{"b":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"15":{"tf":1.0}}}}}},"df":0,"docs":{}},"y":{"df":0,"docs":{},"n":{"c":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"x":{"df":1,"docs":{"7":{"tf":1.0}}}},"df":0,"docs":{}}}}},"t":{"(":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}}},":":{"df":0,"docs":{},"i":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}},"df":0,"docs":{}},"p":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":11,"docs":{"10":{"tf":3.3166247903554},"11":{"tf":3.1622776601683795},"12":{"tf":3.1622776601683795},"13":{"tf":3.3166247903554},"14":{"tf":3.1622776601683795},"4":{"tf":3.1622776601683795},"5":{"tf":1.0},"6":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":3.1622776601683795},"9":{"tf":3.3166247903554}},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"h":{"a":{"df":0,"docs":{},"t":{"'":{"df":1,"docs":{"15":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":1,"docs":{"9":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":1,"docs":{"7":{"tf":1.0}}}}}}}},"o":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"4":{"tf":1.0}}}}}}},"r":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":11,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"2":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"l":{"1":{"df":1,"docs":{"3":{"tf":1.0}}},"]":{"(":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"s":{":":{"/":{"/":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"l":{"d":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"u":{"b":{".":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"/":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"/":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"l":{"1":{".":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":12,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"3":{"tf":1.4142135623730951},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":11,"docs":{"0":{"tf":1.4142135623730951},"10":{"tf":3.0},"11":{"tf":3.0},"12":{"tf":3.0},"13":{"tf":2.8284271247461903},"14":{"tf":2.8284271247461903},"4":{"tf":2.8284271247461903},"6":{"tf":2.8284271247461903},"7":{"tf":2.8284271247461903},"8":{"tf":2.8284271247461903},"9":{"tf":2.8284271247461903}},"i":{"d":{":":{":":{"df":0,"docs":{},"o":{"df":0,"docs":{},"f":{":":{":":{"<":{"df":0,"docs":{},"t":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"u":{"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"n":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"7":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"a":{"c":{"df":0,"docs":{},"h":{"df":10,"docs":{"10":{"tf":2.6457513110645907},"11":{"tf":2.6457513110645907},"12":{"tf":2.6457513110645907},"13":{"tf":2.6457513110645907},"14":{"tf":2.6457513110645907},"4":{"tf":2.6457513110645907},"6":{"tf":2.6457513110645907},"7":{"tf":2.6457513110645907},"8":{"tf":2.6457513110645907},"9":{"tf":2.6457513110645907}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"s":{"a":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}},"p":{"df":2,"docs":{"12":{"tf":1.0},"14":{"tf":1.0}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}}}},"s":{"df":13,"docs":{"0":{"tf":1.4142135623730951},"1":{"tf":2.0},"10":{"tf":6.855654600401044},"11":{"tf":6.6332495807108},"12":{"tf":6.6332495807108},"13":{"tf":7.0},"14":{"tf":6.6332495807108},"3":{"tf":1.7320508075688772},"4":{"tf":6.6332495807108},"6":{"tf":6.708203932499369},"7":{"tf":6.6332495807108},"8":{"tf":6.6332495807108},"9":{"tf":6.708203932499369}}}},"v":{":":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":10,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.7320508075688772},"14":{"tf":1.7320508075688772},"4":{"tf":1.7320508075688772},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772},"8":{"tf":1.7320508075688772},"9":{"tf":1.7320508075688772}}}}}}},"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"12":{"tf":1.0}}},"df":0,"docs":{}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":1,"docs":{"11":{"tf":1.0}}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"15":{"tf":1.0}}}}}}},"w":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":2,"docs":{"12":{"tf":1.0},"8":{"tf":1.0}}}},"y":{"df":2,"docs":{"12":{"tf":1.0},"3":{"tf":1.0}}}},"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"6":{"tf":1.0}}}}}}}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":11,"docs":{"0":{"tf":1.0},"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"0":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"!":{"(":{"df":0,"docs":{},"f":{"df":11,"docs":{"1":{"tf":1.7320508075688772},"10":{"tf":3.605551275463989},"11":{"tf":3.605551275463989},"12":{"tf":3.605551275463989},"13":{"tf":3.872983346207417},"14":{"tf":4.0},"4":{"tf":3.605551275463989},"6":{"tf":3.605551275463989},"7":{"tf":3.605551275463989},"8":{"tf":3.605551275463989},"9":{"tf":3.605551275463989}}}},"df":0,"docs":{}},"df":10,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"l":{"df":0,"docs":{},"n":{"!":{"(":{"df":0,"docs":{},"f":{"df":10,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"4":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"title":{"root":{"c":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":2,"docs":{"10":{"tf":1.0},"11":{"tf":1.0}}}}},"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"4":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"0":{"tf":1.0}}}}}}}}},"r":{"df":1,"docs":{"7":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"d":{"df":0,"docs":{},"e":{"df":1,"docs":{"7":{"tf":1.0}}}},"df":0,"docs":{}}},"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":1,"docs":{"14":{"tf":1.0}}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"c":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"9":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"15":{"tf":1.0}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":8,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"3":{"tf":1.0},"4":{"tf":1.0},"6":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"13":{"tf":1.0},"14":{"tf":1.0}}},"df":0,"docs":{}}}}}}}},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"df":0,"docs":{}}},"f":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"2":{"tf":1.0}}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"11":{"tf":1.0}}},"df":0,"docs":{}}}},"h":{"a":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"l":{"df":1,"docs":{"12":{"tf":1.0}}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":1,"docs":{"5":{"tf":1.0}}}}}},"m":{"a":{"df":0,"docs":{},"p":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"c":{"df":0,"docs":{},"u":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":1,"docs":{"10":{"tf":1.0}}}}}},"s":{"a":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":1,"docs":{"7":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"12":{"tf":1.0}}}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":1,"docs":{"8":{"tf":1.0}}},"df":0,"docs":{}}}},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":2,"docs":{"3":{"tf":1.0},"4":{"tf":1.0}}}}}}}}}}},"pipeline":["trimmer","stopWordFilter","stemmer"],"ref":"id","version":"0.9.5"},"results_options":{"limit_results":30,"teaser_word_count":30},"search_options":{"bool":"OR","expand":true,"fields":{"body":{"boost":1},"breadcrumbs":{"boost":1},"title":{"boost":2}}}};